********************************************************************************
* Menus for MicroEMACS v4.00 copyright Thierry Godefroy 1993-1999.
*
* This source file is to be assembled with the GST macro assembler (or QMAC).
*
*                   23/06/93  Premire implmentation des menus pour MicroEMACS
*                             v3.11.
*
* Modifications:    05/01/94  Les sous-menus ne sont plus premptifs (la barre
*                             de menu reste accessible lorsqu'un sous-menu est
*                             ouvert) et ils ont des positions absolues.
*
*                   06/01/94  Les sous-menus "Fichiers" et "Commandes" utilisent
*                             les extensions de Qmenu si elles sont prsentes.
*                             Un caractre non significatif est envoy aprs
*                             chaque action sur un poste de sous-menu dans la
*                             file d'attente du canal con_ de MicroEMACS pour
*                             effacer le pointeur et ractiver le curseur.
*
*                   08/08/94  Labels globaux renomms pour compatibilit avec
*                             C68 v4.13c.
*
*                   20/08/94  Nouveau sous-menu "variables" implment.
*
*                   07/09/98  Un caractre "null" est maintenant envoy lors de
*                             la fermeture des menus (pour ractiver le curseur
*                             dans la fentre de MicroEMACS).
*
*                   13/09/98  Item "Appel  FileInfo II" ajout dans le sous-
*                             menu "Commandes".
*-------------------------------------------------------------------------------
*                   03/12/98  Adaptation des menus  MicroEMACS v4.00 (suppres-
*                             sion de menubar(), ajout de pop_menu() et de
*                             killer(), positionnement relatif des menus...).
*
*                   08/12/98  Ajout de l'item "undo" et suppression de l'item
*                      au     "Fixer marge droite" au menu "Editer".
*                   10/12/98  Traduction de tous les menus en anglais.
*                             Ajout la possibilit de "coller" les menus.
*                             Ajout des nouvelles variables au menu "variables".
*                             Ajout des sprites "info", "curseur" et "main" (ce
*                             dernier est utilis comme pointeur dans tous les
*                             menus).
*
*                   11/12/98  Les menus n'envoient plus les raccourcis clavier
*                              MicroEMACS mais le nom des fonctions  excuter
*                             (ceci permet de changer tous les "bindings" sauf
*                             "M-X").
*
*                   12/12/98  Chang la taille du menu "variables" pour la
*                             rendre compatible avec un affichage de 512x256.
*                             Ajout de nouveaux items (undos, abbrevs) au menu
*                             "Edit".
*
*                   13/12/98  La fonction "killer()" accepte dsormais un flag
*                             qui, lorsqu'il est non nul, force la destruction
*                             des menus "colls".
*                             Ajout de l'item "Remove mark" au menu "Regions".
*                             Les retours  la ligne sont maintenant des <CR>
*                             au lieu de <LF> (suite au changement de taduction
*                             des caractres dans ql_c).
*
*                   15/12/98  Le slecteur de fichier utilise dsormais le nom
*                             de fichier li au tampon courant comme suggestion
*                             de nom de fichier et de rpertoire. L'adresse du
*                             nom de fichier est passe en paramtre de la
*                             fonction pop_menu().
*
*                   16/12/98  Ajout des items relatifs au "scrap" et de l'item
*                             "Erase kill buffer" au menu "Buffers/screens".
*
*                   19/12/98  Ajout du menu "Help/Bindings".
*
*                   24/12/98  Changement des menus "Moves" et "Region" pour
*                             ajout des items "Copy to scrap" et "Insert scrap".
*
*                   25/12/98  Ajout de l'item "List all variables" au sous-menu
*                             "Variables/Modes".
*
*                   26/12/98  Ajout de l'item "Exec buffer as macro" au sous-
*                             menu "Commands"; rorganisation de ce sous-menu.
*
*                   30/12/98  Un "wake event" est maintenant envoy  MicroEMACS
*                             lorsqu'un sous-menu est referm avec "ESC", de
*                             faon  forcer la disparition du pointeur et
*                             l'activation du curseur.
*
*                   31/12/98  Ajout de l'item "Apropos commands/proc." dans le
*                             sous-menu "Help/Bindings".
*
*                   01/01/99  Ajout du menu contextuel.
*
*                   02/01/99  L'argument des commandes est maintenant stock
*                             dans la zone de donnes de chaque sous-menu,
*                             vitant ainsi d'auto-modifier ce code et d'avoir
*                             un argument commun  tous les sous-menus.
*                             La taille de l'item d'argument a t lgrement
*                             augmente pour accepter des arguments  six
*                             chiffres.
*                             Ajout l'item "Search word" au sous-menu "Search"
*                             et l'item "Select word as region" au sous-menu
*                             "Regions".
*
*                   17/01/99  Ajout les items "Copy to scrap", "Insert scrap"
*                             et "Spell check from here" au menu contextuel.
*
*                   27/01/99  Corrig le raccourci clavier de l'item "List all
*                             variables" du sous-menu "Help".
*
*                   02/02/99  Ajout les items "Tag word", "Re-tag word" et
*                             "Back from tagged word" au sous-menu "Search",
*                             ainsi que l'item "Tag this word" au sous-menu
*                             "Context".
*
*                   09/02/99  Ajout l'item "Print" au sous-menu "Files".
*
*                   28/02/99  Ajout les noms de variables spcifiques au QDOS
*                             dans le sous-menu "Variables".
*
*                   20/03/99  Ajout l'item "Insert a character" au sous-menu
*                             contextuel.
*
*                   23/04/99  Correction d'un bogue dans FSELECT o le passage
*                             d'un pointeur NULL n'tait pas vrifi.
*
*                   13/05/99  Ajout des items "Start server" et "Stop server" au
*                             menu "Commands".
*
*                   26/10/99  Ajout des items "Select a filename & ..." et
*                             "...call FileInfo II" au menu contextuel. Pour ce
*                             dernier item, deux commandes doivent tre envoyes
*                              MicroEMACS et une temporisation est ncessaire
*                             (appel  WAIT dans SEND_CMD) entre les deux.
*
*                   03/11/99  Ajout du sprite "fist_spr".
*
*                   04/11/99  Ajout du flag "_insubmenu" pour indiquer au pilote
*                             de "fast_s" que l'cran de MicroEMACS est
*                             vrouill suite  un appel  FSEL ou au sous-menu
*                             "Variables".
*
*                   15/11/99  Ajout du mode "HILITE" au sous-menus "Variables/
*                             Modes".
*                             Ajout des nouvelles variables lies au mode
*                             "HILITE" au sous-menus "Variables".

          section   text

* Rfrences aux fonctions externes:

          xref      _in_put

* Rfrences aux variables externes:

          xref      _insubmenu

* Dfinitions des fonctions:
*
* void killer(int flag);
* chanid_t pop_menu(int menu, char * fname);

          xdef      _killer
          xdef      _pop_menu

* Pointeurs sur des objets utiliss dand "ql_c":

          xdef      _info_spr
          xdef      _pgdn_spr
          xdef      _pgup_spr
          xdef      _curs_spr
          xdef      _hand_spr
          xdef      _fist_spr

* Longueur et taille de la zone des donnes du job:

JOBCODELN equ       32
JOBSTAKLN equ       6*1024

* Offset des variables dans la zone des donnes du job:

STICKED   equ       0
STICKITEM equ       2
EMACS_ID  equ       4
FILENAME  equ       8
WMANVEC   equ       12
ITEM0     equ       16
ITEM      equ       20
SELMODE   equ       24
MENUCHAN  equ       28
MENUDEF   equ       32
ARGUMENT  equ       36
WORKDEF   equ       48
FSELPARS  equ       3300
FSELFNAM  equ       3500
FSELRET   equ       3700

_killer   MOVEM.L   D2-D5/A2/A3,-(SP)             Sauver le contexte.
          MOVE.L    28(SP),D5                     Flag pour tuer menus "colls".
KILLAGAIN MOVEQ     #0,D1                         Commencer avec le S-Basic.
          BRA.S     KILLER0                       Chercher et tuer ancien job.
KILLER1   TST.L     D1                            Est-ce le dernier job ?
          BEQ.S     KILLER3                       Si oui fin de la recherche.
KILLER0   MOVE.L    D1,D4                         Sauver idenficateur du job.
          MOVEQ     #0,D2                         Job pre = S-Basic.
          MOVEQ     #2,D0                         | Prendre les informations
          TRAP      #1                            | sur le job.
          LEA       8(A0),A1                      Adr de l'ventuel nom du job.
          LEA       JOBNAME1,A2                   Adresse nom job  dtruire.
          MOVEQ     #3,D0                         Quatre mots longs  comparer.
KILLER2   CMPM.L    (A1)+,(A2)+                   Comparer un mot long.
          BNE.S     KILLER1                       Si <> passer au job suivant.
          DBRA      D0,KILLER2                    Continuer la comparaison.
          TST.L     D5                            Faut-il tuer les menus colls?
          BNE.S     KILLER4                       Si oui, sauter ce qui suit...
          TST.W     STICKED+JOBCODELN(A0)         Le menu est-il "coll" ?
          BNE.S     KILLER1                       Si oui, passer au job suivant.
KILLER4   MOVE.L    D4,D1                         Prendre identificateur du job.
          MOVEQ     #0,D3                         Pas d'erreur  transmettre.
          MOVEQ     #5,D0                         | Tuer le job.
          TRAP      #1                            |
          BRA.S     KILLAGAIN                     Chercher jobs suivants.
KILLER3   MOVEM.L   (SP)+,D2-D5/A2/A3             Restaurer le contexte.
          RTS                                     Retour.

_pop_menu MOVEM.L   D2-D4/A3,-(SP)                Sauvegarde du contexte.
          MOVEQ     #0,D0                         | Chercher l'Id du job courant
          TRAP      #1                            |  (c..d. de MicroEMACS).
          MOVE.L    D1,D4                         Placer l'Id au dbut datas.
          MOVE.L    #JOBSTAKLN,D3                 Taille de sa zone de data.
          MOVEQ     #JOBCODELN,D2                 Taille du code du job.
          MOVEQ     #-1,D1                        Job pre = job courant.
          SUBA.L    A1,A1                         Pas d'adr de dpart impose.
          MOVEQ     #1,D0                         | Rserver une zone pour
          TRAP      #1                            |  le nouveau job.
          TST.L     D0                            Erreur ?
          BNE.S     POPMENU1                      Si oui, retour.
          LEA       20(SP),A1                     Adresse dbut des paramtres.
          CLR.W     STICKED(A0,D2.L)              Le menu n'est pas "coll".
          MOVE.L    D4,EMACS_ID(A0,D2.L)          | Placer les donnes au dbut
          MOVE.L    (A1)+,D0                      |  de la zone de data (Id de
          MOVE.W    D0,ITEM0(A0,D2.L)             |  MicroEMACS, n de menu et
          MOVE.L    (A1),FILENAME(A0,D2.L)        |  nom du fichier courant.
          MOVE.W    #$4EF9,(A0)+                  Placer un JMP.
          LEA       MENUJOB(PC),A1                Adresse de dbut code du job.
          MOVE.L    A1,(A0)+                      Placer l'adresse aprs JMP.
          MOVE.W    #$4AFB,(A0)+                  Mot de repre.
          LEA       JOBNAME1(PC),A1               Ptr sur nom du job.
          MOVE.W    (A1)+,D0                      Nombre de caractres du nom.
          MOVE.W    D0,(A0)+                      Les placer dans header du job.
          SUBQ.W    #1,D0                         Prparer compteur DBRA.
POPMENU2  MOVE.B    (A1)+,(A0)+                   Transfrer un caractre.
          DBRA      D0,POPMENU2                   Recommencer pour tout le nom.
          MOVEQ     #8,D2                         Priorit du job.
          MOVEQ     #0,D3                         Temporisation nulle.
          MOVEQ     #$A,D0                        | Activer le job.
          TRAP      #1                            |
          MOVE.L    D1,D0                         Retourner l'Id du job.
POPMENU1  MOVEM.L   (SP)+,D2-D4/A3                Restaurer le contexte.
          RTS

MENUJOB   LEA       0(A6,A4.L),A5                 Adresse de la zone de data.
          MOVEQ     #-1,D6                        Pas de menu ouvert.
MENUJOB0  TST.L     D6                            Y-a-t'il un menu ouvert ?
          BPL.S     MENUJOB1                      Si oui, sauter ce qui suit...
          LEA       MENU_LIST(PC),A4              Adresse de la liste de menus.
          MOVE.W    ITEM0(A5),D0                  Numro item actionn.
          LSL.W     #1,D0                         Index --> Offset.
          ADDA.W    0(A4,D0.W),A4                 Ajouter offset  l'adresse.
          MOVE.L    A4,MENUDEF(A5)                Sauver adr dfinition menu.
          MOVE.L    A4,D7                         Idem pour "PULDOWN".
          LEA       WORKDEF(A5),A4                Adresse base zone tampon.
          BSR       PULLDOWN                      Ouvrir le menu.
          BNE.S     MENUJOB4                      Si erreur, tuer ce job.
MENUJOB1  MOVEA.L   MENUDEF(A5),A1                Adr de la dfinition du menu.
          MOVE.W    -4(A1),D1                     Numro du loose item "stick".
          BMI.S     MENUJOB7                      Si pas de loose item, sauter.
          LEA       UNST_SPR,A1                   Adresse du sprite "unstick".
          TST.W     STICKED(A5)                   Tester le flag "menu coll" ?
          BEQ.S     MENUJOB8                      Si menu non coll, sauter...
          LEA       STIK_SPR,A1                   Adresse du sprite "stick".
MENUJOB8  JSR       $4C(A2)                       Changer l'item.
          BSR       LMI_DRAW                      Redessiner les items.
MENUJOB7  CLR.L     FSELRET(A5)                   RAZ du flag de FSEL/variable.
          CLR.B     FSELPARS(A5)                  RAZ du flag de TRUE/FALSE.
          MOVEA.L   WMANVEC(A5),A2                Vecteur du window manager.
          JSR       $30(A2)                       Lire un vnement pointeur.
          BNE.S     MENUJOB4                      Si erreur, refermer le menu.
          MOVEA.L   (A4),A1                       Pointeur sur "status area".
          LEA       $15(A1),A1                    Ptr sur "window event vector".
          BTST      #1,(A1)                       Evnement "cancel" ?
          BNE.S     MENUJOB3                      Si oui, poursuivre...
          BTST      #3,(A1)                       Evnement "wmove".
          BEQ.S     MENUJOB2                      Si non, sauter ce qui suit.
          JSR       $40(A2)                       Changer la position du menu.
          BNE.S     MENUJOB4                      Si erreur, refermer le menu.
MENUJOB2  BSR       LMI_DRAW                      Redessiner les items.
          BEQ.S     MENUJOB1                      Relire le pointeur.
MENUJOB3  TST.W     FSELRET(A5)                   Faut-il utiliser FSEL ?
          BEQ.S     MENUJOB4                      Si non, sauter ce qui suit.
          ST        _insubmenu                    Flag "dans sous-menu"  -1.
          BMI.S     MENUJOB5                      Si FSEL, sauter ce qui suit.
          BSR       VARSELCT                      Slectionner une variable.
          MOVEQ     #-1,D6                        Le menu a t referm.
          BRA.S     MENUJOB4                      Poursuivre le traitement.
MENUJOB5  BSR       FSELECT                       Utiliser FSEL de QMenu.
          MOVEQ     #-1,D6                        Le menu a t referm.
MENUJOB4  SF        _insubmenu                    Effacer flag "dans sous-menu".
          MOVE.L    D0,D7                         Sauver code d'erreur.
          MOVEQ     #-1,D3                        Temporisation infinie.
          MOVEQ     #8,D2                         Envoyer un wake event.
          MOVE.L    EMACS_ID(A5),D1               Id du job MicroEMACS.
          MOVEQ     #$7C,D0                       | Remettre le job en premier
          TRAP      #3                            |  plan.
          MOVEM.L   D1/D3/A0/A1,-(SP)             Sauver le contexte.
          SUBA.L    A1,A1                         Pas de flag  effacer.
          MOVEQ     #5,D3                         | Suspendre le job 1/10s.
          MOVEQ     #-1,D1                        |
          MOVEQ     #8,D0                         |
          TRAP      #1                            |
          MOVEM.L   (SP)+,D1/D3/A0/A1             Restaurer le contexte.
          TST.L     D7                            Y-avait-il eu une erreur ?
          BNE.S     MENUJOB6                      Si oui, sauter ce qui suit.
          TST.W     STICKED(A5)                   Le menu est-il "coll" ?
          BNE       MENUJOB0                      Si oui, reboucler...
MENUJOB6  MOVEQ     #0,D3                         Pas d'erreur.
KILL_JOB  MOVEQ     #-1,D1                        Job = job courant.
          MOVEQ     #5,D0                         | Supprimer le job et envoyer
          TRAP      #1                            |  le code d'erreur (dans D3).

********************************************************************************
* Pulldown routine:
* ~~~~~~~~~~~~~~~~

PULLDOWN  LEA       CONSOLE(PC),A0                Nom du canal console.
          MOVEQ     #0,D3                         Fichier type priphrique.
          MOVEQ     #-1,D1                        Propritaire = job courant.
          MOVEQ     #1,D0                         | Ouvrir le canal console.
          TRAP      #2                            |
          TST.L     D0                            Erreur ?
          BNE       PULLD5                        Si oui, fin.
          MOVE.L    A0,D6                         | Sauvegarde de l'id du canal.
          MOVE.L    A0,MENUCHAN(A5)               |
          MOVEQ     #-1,D3                        Temporisation infinie.
          MOVEQ     #$70,D0                       | Prendre le vecteur du
          TRAP      #3                            |  "window manager".
          MOVE.L    D0,D5                         Erreur ?
          BNE       PULLD4                        Si oui, retour.
          MOVEQ     #-19,D5                       Code erreur "non rpertori".
          MOVE.L    A1,D0                         Vecteur nul (pas de Wman) ?
          BEQ.S     PULLD4                        Si oui, fin.
          MOVE.L    A1,WMANVEC(A5)                Sauver le vecteur.
          MOVEA.L   D7,A1                         Adresse de dfinition du menu.
          MOVE.B    8(A1),D1                      Flag de mode d'affichage.
          BLT.S     PULLD2                        Si flag = -1 ne rien changer.
          MOVEQ     #-1,D1                        Lecture du mode d'affichage.
PULLD1    MOVEQ     #-1,D2                        Lecture du type d'affichage.
          MOVE.L    A4,-(SP)                      Sauver A4.
          MOVEQ     #$10,D0                       | Lire/changer le mode
          TRAP      #1                            |  d'affichage.
          MOVEA.L   (SP)+,A4                      Restaurer A4.
          MOVE.B    D1,D0                         Mode d'affichage actuel.
          MOVEQ     #8,D1                         | Mode d'affichage requis.
          MOVEA.L   D7,A1                         |
          AND.B     8(A1),D1                      |
          OR.B      D0,D1                         | Mode actuel = mode requis ?
          CMP.B     D0,D1                         |
          BNE.S     PULLD1                        Si non, changer de mode.
PULLD2    MOVEA.L   D7,A3                         Pointeur sur dfinition menu.
          MOVEA.L   A4,A1                         Pointeur sur "working def.".
          ADDA.L    (A3),A1                       Pointeur sur "status area".
          MOVE.L    4(A3),D0                      Longueur "status area".
          LSR.L     #2,D0                         Longueur en mots longs.
          SUBQ.L    #1,D0                         Pour compteur DBRA.
          MOVEA.L   A1,A2                         Recopie ptr "status area".
PULLD0    CLR.L     (A2)+                         | RAZ "status area".
          DBRA      D0,PULLD0                     |
          LEA       ARGUMENT(A5),A2               | RAZ de l'argument.
          CLR.W     (A2)                          |
          CLR.L     SELMODE(A5)                   RAZ du mode slectionn.
          MOVEA.L   D6,A0                         Restaurer Id du canal "con_".
          MOVEA.L   WMANVEC(A5),A2                Vecteur du window manager.
          LEA       14(A3),A3                     Dfinition du menu.
          MOVEQ     #0,D1                         Utilise taille par dfaut.
          JSR       4(A2)                         Mise en place fentre manage.
          MOVEQ     #-1,D1                        Positionnement par dfaut.
          MOVEA.L   D7,A1                         Pointeur sur dfinition menu.
          CMP.B     9(A1),D1                      Position absolue requise ?
          BNE.S     PULLD3                        Si non, passe  la suite.
          MOVE.L    10(A1),D1                     Coordonnes requises.
PULLD3    JSR       $C(A2)                        Positionner le menu.
          MOVE.L    D0,D5                         Test et sauvegarde erreur.
          BNE.S     PULLD4                        Si erreur, retour.
          JSR       $1C(A2)                       Dessiner le menu.
          MOVE.L    D0,D5                         Test et sauvegarde erreur.
          BEQ.S     PULLD5                        Si pas d'erreur, retour.
          MOVEQ     #2,D0                         | Refermer le canal du menu.
          TRAP      #2                            |
PULLD4    MOVEA.L   D6,A0                         Id. du canal "con_".
          MOVEQ     #2,D0                         | Refermer le canal "con_".
          TRAP      #2                            |
          MOVE.L    D5,D0                         Erreur.
PULLD5    RTS                                     Retour.

********************************************************************************
* Action routines:
* ~~~~~~~~~~~~~~~

EVENT0    CLR.W     STICKED(A5)                   Autoriser destruction du menu.
EVENT     BSR.S     UNSELECT                      Dslectionner l'item.
          MOVEQ     #14,D4                        Numro event - code event.
          ADD.B     $B(A3),D4                     Ajouter code event.
          MOVEQ     #0,D0                         Pas d'erreur.
          RTS                                     Retour.

STICK     BSR.S     UNSELECT                      Dslectionner l'item.
          MOVE.W    $10(A3),D1                    Numro de l'item.
          LEA       UNST_SPR,A1                   Adresse du sprite "unstick".
          TST.W     STICKED(A5)                   Tester le flag "menu coll" ?
          SEQ       STICKED(A5)                   Et l'inverser.
          BNE.S     STICK1                        Si menu non coll, sauter...
          LEA       STIK_SPR,A1                   Adresse du sprite "stick".
STICK1    JSR       $4C(A2)                       Changer l'item.
          MOVEQ     #0,D4                         Pas d'vnement  retourner.
          BRA.S     LMI_DRAW                      Redessiner les items.

ACTION    BSR.S     UNSELECT                      Dslectionner le bouton
          MOVE.W    $10(A3),ITEM(A5)              Sauver n du bouton actionn.
          MOVEQ     #16,D4                        Retourner un "DO event".
          MOVEQ     #0,D0                         Pas d'erreur.
          RTS                                     Retour.

UNSELECT  MOVE.W    $10(A3),D0                    Numro du bouton actionn.
          MOVE.B    #1,$40(A1,D0.W)               Rendre le bouton disponible.
          MOVEQ     #0,D0                         Pas d'erreur.
          RTS                                     Retour.

TRUEFALSE MOVE.W    #TRUEITEM,D5                  Premier item  dslectionner.
          MOVE.W    #FALSEITEM,D7                 Dernier item  dslectionner.
          BRA.S     SELECT0                       Slectionner l'item.
SELECTONE MOVEQ     #FIRSTMODE,D5                 Premier item  dslectionner.
          MOVEQ     #LASTMODE,D7                  Dernier item  dslectionner.
SELECT0   MOVE.L    $C(A3),D0                     Adresse du nom de l'item.
          MOVE.W    $10(A3),D1                    Numro de l'item slectionn.
          BTST      #7,$40(A1,D1.W)               Le bouton est-il slectionn ?
          BNE.S     SELECT3                       Si oui, sauter ce qui suit.
          MOVEQ     #0,D0                         RAZ de l'adresse.
SELECT3   MOVE.L    D0,SELMODE(A5)                Sauver l'adresse du nom item.
SELECT1   CMP.W     D7,D1                         Est-ce l'item slectionn ?
          BEQ.S     SELECT2                       Si oui, ne pas dselectionner.
          BCLR      #7,$40(A1,D7.W)               Rendre le bouton disponible.
          BEQ.S     SELECT2                       S'il l'tait dj, sauter.
          BSET      #0,$40(A1,D7.W)               Flag pour redessiner bouton.
SELECT2   SUBQ.W    #1,D7                         Pointer item prcdent.
          CMP.W     D5,D7                         Dernier item  vrifier ?
          BGE.S     SELECT1                       Si non recommencer.

LMI_DRAW  MOVEQ     #0,D3                         | Redessiner tous les items.
          JMP       $2C(A2)                       |

CHANGE    BSR.S     UNSELECT                      Dselectionner l'item.
          MOVE.W    $10(A3),D1                    Numro de l'item.
          MOVEQ     #0,D2                         Ne pas changer les attributs.
          JSR       $5C(A2)                       Taille fentre = taille item.
          LEA       ARGUMENT(A5),A1               Tampon contenant l'argument.
          JSR       $4C(A2)                       Changer l'item.
          JSR       $68(A2)                       Editer l'argument.
          BRA.S     LMI_DRAW                      Redessiner les items.

LI_NAME   MOVEA.L   $C(A3),A1                     Adresse du nom de l'item.
          LEA       FSELRET(A5),A2                Adr de stockage nom de l'item.
          MOVE.W    (A1),D0                       Nombre de caractres  copier.
          ADDQ.W    #1,D0                         Tenir compte mot de longueur.
LI_NAME1  MOVE.B    (A1)+,(A2)+                   | Transfrer le nom de l'item
          DBRA      D0,LI_NAME1                   |  dans tampon de stockage.
          TST.B     FSELPARS(A5)                  TRUE/FALSE autoriss ?
          BEQ.S     LI_NAME2                      Si non, sauter ce qui suit.
          MOVE.B    $A(A3),FSELPARS(A5)           TRUE/FALSE si $ soulign.
LI_NAME2  MOVEQ     #16,D4                        Retourner un "DO event".
          MOVEQ     #0,D0                         Pas d'erreur.
          RTS                                     Retour.

SENDFVAR  ST        FSELPARS(A5)                  Flag autorisation TRUE/FALSE.
SEND_VAR  MOVE.W    #1,FSELRET(A5)                Flag pour appel sous menu var.
          BRA.S     SEND_CMD                      Envoyer la commande.
SEND_FNAM ST        FSELRET(A5)                   Flag pour appel de FSEL.
SEND_CMD  BSR       UNSELECT                      Dslectionner l'item.
          LEA       ARGUMENT(A5),A1               Pointer l'argument ventuel.
          TST.W     (A1)                          Y-a-t'il un argument ?
          BEQ.S     SEND1                         Si non, sauter ce qui suit.
          MOVEQ     #27,D0                        Code de "ESC".
          BSR.S     SEND_ONE                      Envoyer "ESC".
          BSR.S     SEND_THEM                     Envoyer l'argument.
SEND1     MOVEQ     #27,D0                        | Envoyer ESC X (excuter
          BSR.S     SEND_ONE                      |  une commande nomme).
          MOVEQ     #'X',D0                       |
          BSR.S     SEND_ONE                      |
          MOVEA.L   MENUDEF(A5),A1                Ptr sur descripteur du menu.
          ADDA.W    -2(A1),A1                     Pointeur sur table de ptr.
          MOVE.W    $10(A3),D0                    Numro de l'item.
          LSL.W     #1,D0                         Index --> Offset.
          ADDA.W    0(A1,D0.W),A1                 Pointeur sur nom de commande.
          BSR.S     SEND_THEM                     envoyer la commande.
          MOVEQ     #13,D0                        | Envoyer "RETURN".
          BSR.S     SEND_ONE                      |
          MOVE.W    $10(A3),D0                    Numro de l'item.
          SUBQ.W    #MODEITEM,D0                  Est-il li aux MODEs de E ?
          BMI.S     SEND2                         Si oui, sauter ce qui suit.
          TST.L     SELMODE(A5)                   Mode slectionn ?
          BEQ.S     SEND2                         Si non, sauter ce qui suit.
          MOVEA.L   SELMODE(A5),A1                Adresse de l'item de mode.
          BSR.S     SEND_THEM                     Envoyer son nom.
          MOVEQ     #13,D0                        | Envoyer "RETURN".
          BSR.S     SEND_ONE                      |
SEND2     BSR       LMI_DRAW                      Redessiner les items.
          MOVEQ     #17,D4                        Numro d'vnement "cancel".
          MOVEQ     #0,D0                         Pas d'erreur.
          RTS

SEND_ONE  MOVEQ     #0,D5                         Un seul caractre  envoyer.
          BRA.S     SEND_3                        Envoyer le code du caractre.
SEND_THEM MOVE.W    (A1)+,D5                      Nombre d'octets de la chane.
          BRA.S     SEND_1                        Commencer le transfert.
SEND_2    MOVEQ     #0,D0                         RAZ octet de poids fort.
          MOVE.B    (A1)+,D0                      Caractre  envoyer.
          BNE.S     SEND_3                        Si <> 0, sauter ce qui suit.
          BSR.S     WAIT                          Effectuer une pause.
          BRA.S     SEND_1                        Passer au caractre suivant.
SEND_3    MOVEM.L   D1-D7/A0-A6,-(SP)             Sauvegarde du contexte.
          MOVE.L    D0,-(SP)                      Passer un entier long.
          JSR       _in_put                       L'envoyer dans le tampon.
          ADDQ.L    #4,SP                         Dpiler le paramtre.
          MOVEM.L   (SP)+,D1-D7/A0-A6             Restaurer le contexte.
SEND_1    DBRA      D5,SEND_2                     Recommence pour octet suivant.
          MOVEQ     #0,D0                         Pas d'erreur.
          RTS                                     Retour.

WAIT      MOVEM.L   D1/D3/A0/A1,-(SP)             Sauver le contexte.
          SUBA.L    A1,A1                         Pas de flag.
          MOVEQ     #10,D3                        Temporisation = 1/5 seconde.
          MOVEQ     #-1,D1                        Job = job courant.
          MOVEQ     #8,D0                         | Suspendre le job.
          TRAP      #1                            |
          MOVEM.L   (SP)+,D1/D3/A0/A1             Restaurer le contexte.
          RTS                                     Retour.

********************************************************************************
* Routines d'utilisation de QMenu:
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

FSELECT   MOVEA.L   WMANVEC(A5),A2                Vecteur WMAN.
          JSR       $14(A2)                       Supprimer dfinition du menu.
          MOVEQ     #2,D0                         | Fermer le canal du menu.
          TRAP      #2                            |
          MOVEA.L   MENUCHAN(A5),A0               | Fermer le canal con_.
          MOVEQ     #2,D0                         |
          TRAP      #2                            |
          LEA       CONSOLE,A0                    Adresse nom du canl con_.
          MOVEQ     #0,D3                         Priphrique exclusif.
          MOVEQ     #-1,D1                        Propritaire = job courant.
          MOVEQ     #1,D0                         | Ouvrir un canal 'con_'
          TRAP      #2                            |
          MOVE.L    A0,MENUCHAN(A5)               Sauvegarde de l'Id du canal.
          LEA       MENUS,A0                      Nom de la chose.
          MOVE.L    #'FSEL',D2                    Nom de l'extension.
          BSR       USE_THING                     Utiliser la chose "Menus".
          BNE       FSELECT1                      Si erreur, retour.
          MOVEA.L   A1,A4                         Adresse de l'entte de QMenu.
          MOVEA.L   MENUCHAN(A5),A0               Id du canal con_.
          LEA       FSELRET(A5),A1                Pointeur pour rsultat.
          MOVEQ     #-1,D3                        Temporisation infinie.
          MOVEQ     #0,D2                         Mandatoire.
          MOVEQ     #$6C,D0                       | Chercher les limites de
          TRAP      #3                            |  l'cran.
          MOVEQ     #0,D2                         Ne pas conserver le contenu.
          MOVEQ     #0,D1                         Pas d'ombre requise.
          MOVEQ     #$7A,D0                       | Fixer les limites de la
          TRAP      #3                            |  fentre.
          LEA       FSELPARS(A5),A1               Adr base liste paramtres.
          MOVEQ     #-1,D0                        Valeur par dfaut.
          MOVE.L    #$C1000000,D1                 Type paramtre (call+str par).
          MOVE.L    D1,(A1)+                      Stocker le type du 1er param.
          LEA       TITLE,A2                      Adresse du nom du menu.
          MOVE.L    A2,(A1)+                      Stocke dans liste paramtres.
          MOVE.L    D1,(A1)+                      | Par dfaut, pas de nom de
          CLR.L     (A1)+                         |  fichier.
          MOVE.L    D0,(A1)+                      | Par dfaut, pas de nom de
          MOVE.L    D0,(A1)+                      |  rpertoire, prend DATA_USE.
          MOVE.L    D1,(A1)+                      | Par dfaut, pas de nom
          CLR.L     (A1)+                         |  d'extension.
          CLR.L     (A1)+                         Pas de restriction lignes/col.
          MOVE.L    D0,(A1)+                      | Position de la fentre =
          MOVE.L    D0,(A1)+                      |  position par dfaut.
          MOVE.L    #1,(A1)+                      Couleurs menu: rouge/noir.
          MOVE.L    #3,(A1)+                      Couleurs fentre: vert/noir.
          MOVE.L    #$A100002A,(A1)+              Type paramtre=ret+str+42chr.
          LEA       FSELRET(A5),A2                Adr pour retour nom fichier.
          MOVE.L    A2,(A1)                       Stocke dans liste paramtres.
          CLR.L     (A2)                          Pas de nom pour l'instant.
          LEA       FSELPARS(A5),A1               Adr base liste paramtres.
          MOVE.L    FILENAME(A5),D0               Pointeur sur nom de fichier.
          BEQ.S     FSELECT2                      Si NULL, sauter ce qui suit.
          MOVEA.L   D0,A2                         Pointeur sur nom de fichier.
          TST.B     (A2)                          Est-ce une chane vide ?
          BEQ.S     FSELECT2                      Si oui, sauter ce qui suit
          LEA       FSELFNAM+2(A5),A0             Adresse du tampon pour le nom.
          MOVEQ     #0,D0                         RAZ du compteur de caractres.
FSELECT5  ADDQ.W    #1,D0                         Un caractre de plus.
          MOVE.B    (A2)+,(A0)+                   Transfert du caractre.
          BNE.S     FSELECT5                      Si <>0, continuer transfert.
          SUBQ.W    #1,D0                         Ne pas compter le NULL.
          LEA       FSELFNAM(A5),A0               Adresse de la chane.
          MOVE.W    D0,(A0)                       Stocker longueur de chane.
          MOVE.L    A0,$C(A1)                     Suggestion de nom de fichier.
          MOVE.L    D1,$10(A1)                    | Stocker type paramtre et
          MOVE.L    A0,$14(A1)                    |  adresse nom de rpertoire.
FSELECT2  JSR       $18(A4)                       Appeler l'extension menu.
          MOVE.L    D0,D7                         Sauver code d'erreur.
          LEA       MENUS,A0                      Nom de la chose.
          BSR       FREE_THG                      Librer la chose "Menu".
          MOVE.L    D7,D0                         Restaurer code d'erreur.
          BMI.S     FSELECT1                      Si erreur, retour immdiat.
          CMPI.B    #1,D0                         ESC presse ?
          BNE.S     FSELECT3                      Si non, sauter ce qui suit.
          MOVEQ     #7,D0                         Code de CTRL G (annulation).
          BRA.S     FSELECT4                      Envoyer ce code.
FSELECT3  LEA       FSELRET(A5),A1                Adresse chane retourne.
          TST.W     (A1)                          Chane vide ?
          BEQ.S     FSELECT1                      Si oui, retour.
          BSR       SEND_THEM                     |
          MOVEQ     #13,D0                        | Envoyer la chane + RETURN.
FSELECT4  BSR       SEND_ONE                      |
FSELECT1  MOVEA.L   MENUCHAN(A5),A0               Id du canal con_ du sous-menu.
          MOVEQ     #2,D0                         | Fermer le canal du menu.
          TRAP      #2                            |
          MOVEQ     #0,D0                         Pas d'erreur.
          RTS                                     Retour.

********************************************************************************
* Gestion du menu de slection des noms de variable.

VARSELCT  MOVEA.L   WMANVEC(A5),A2                Vecteur WMAN.
          JSR       $14(A2)                       Supprimer dfinition du menu.
          MOVEQ     #2,D0                         | Fermer le canal du menu.
          TRAP      #2                            |
          LEA       VARIABLES(PC),A4              Adresse dfinition du menu.
          MOVE.L    A4,D7                         La sauver.
          LEA       WORKDEF(A5),A4                Adr zone pour "working def.".
          BSR       PULLDOWN                      Dessiner sous-menu variables.
          BNE       VARSEL4                       Si erreur, retour.
          CLR.L     SELMODE(A5)                   Effacer adr item TRUE/FALSE.
          TST.B     FSELPARS(A5)                  TRUE/FALSE autoris ?
          BNE.S     VARSEL1                       Si oui, sauter ce qui suit.
          LEA       WORKDEF(A5),A4                Restaurer ptr sur "work def.".
          MOVEA.L   (A4),A1                       | Rendre les items "TRUE" et
          MOVE.B    #$11,TRUEITEM+$40(A1)         |  "FALSE" indisponibles.
          MOVE.B    #$11,FALSEITEM+$40(A1)        |
          MOVEA.L   WMANVEC(A5),A2                Vecteur WMAN.
          BSR       LMI_DRAW                      Redessiner les items.
VARSEL1   MOVEA.L   WMANVEC(A5),A2                Vecteur du window manager.
          JSR       $30(A2)                       Lire un vnement pointeur.
          BNE.S     VARSEL7                       Si erreur, refermer le menu.
          MOVEA.L   (A4),A1                       Pointeur sur "status area".
          LEA       $15(A1),A1                    Ptr sur "window event vector".
          BTST      #0,(A1)                       Evnement "DO" ?
          BNE.S     VARSEL3                       Si oui, envoyer paramtres.
          BTST      #1,(A1)                       Evnement "cancel" ?
          BEQ.S     VARSEL5                       Si non, poursuivre...
          MOVEQ     #7,D0                         Code de CTRL G (annulation).
          BRA.S     VARSEL6                       Envoyer ce code.
VARSEL5   BTST      #3,(A1)                       Evnement "wmove".
          BEQ.S     VARSEL2                       Si non, sauter ce qui suit.
          JSR       $40(A2)                       Changer la position du menu.
          BNE.S     VARSEL7                       Si erreur, refermer le menu.
VARSEL2   BSR       LMI_DRAW                      Redessiner les items.
          BEQ.S     VARSEL1                       Relire le pointeur.
VARSEL3   LEA       FSELRET(A5),A1                Adr nom de variable  envoyer.
          TST.W     (A1)                          Y-a-t'il un nom ?
          BEQ.S     VARSEL7                       Si non, fin.
          MOVEQ     #'%',D0                       |
          CMP.B     2(A1),D0                      | Est-ce l'item "%..." ?
          BEQ.S     VARSEL6                       Si oui n'envoyer que "%".
          BSR       SEND_THEM                     Envoyer le nom de variable.
          MOVEQ     #13,D0                        Caractre <RETURN>.
          BSR       SEND_ONE                      Envoyer le <RETURN>.
          TST.B     FSELPARS(A5)                  Faut-il envoyer TRUE/FALSE ?
          BEQ.S     VARSEL7                       Si non, fin.
          MOVE.L    SELMODE(A5),D0                Adresse de TRUE/FALSE.
          BEQ.S     VARSEL7                       Si nulle, fin.
          MOVEA.L   D0,A1                         | Envoyer la valeur "TRUE"
          BSR       SEND_THEM                     |  ou "FALSE".
          MOVEQ     #13,D0                        Code de <RETURN>.
VARSEL6   BSR       SEND_ONE                      Envoyer le caractre.
VARSEL7   JSR       $14(A2)                       Supprimer dfinition du menu.
          MOVEQ     #2,D0                         | Fermer le canal du menu.
          TRAP      #2                            |
VARSEL4   MOVEQ     #0,D0                         Pas d'erreur.
          RTS

********************************************************************************
* Routines d'utilisation et de libration d'une chose:
* ===================================================
*
* Paramtres en entre: D0.L = $28 ou $29 (si appel de DO_THING),
* ~~~~~~~~~~~~~~~~~~~~  D1.L = Id du job concern (si appel de USE_THG),
*                       D2.L = Paramtre supplmentaire ventuel (selon chose),
*                       D3.L = Paramtre supplmentaire ventuel (si FREE_THG),
*                       A0.L = Pointeur sur le nom de la chose,
*                       A1.L = Paramtre supplmentaire ventuel (FREE_THG),
*                       A2.L = Paramtre supplmentaire ventuel (selon chose),
*
* Paramtres en sortie: D0.L = Code d'erreur,
* ~~~~~~~~~~~~~~~~~~~~  D1.L = Id du job concern (ou -1 si appel de FREE_THG),
*                       D2.L = Rsultat (selon la chose),
*                       D3.L = Version de la chose (si SMS.UTHG) ou prserv,
*                       D4.L  D7.L: prservs,
*                       A1.L = Pointeur sur la chose (si SMS.UTHG) ou prserv,
*                       A2.L = Ptr/bloc chainage chose (si SMS.UTHG) ou rsultat
*                       A0.L, A3.L  A7.L: prservs.

FREE_THG  MOVEQ     #-1,D1                        Job utilisateur=job courant.
          MOVEQ     #$29,D0                       Code pour appel  SMS.FTHG.
          BRA.S     DO_THG

USE_THING MOVEQ     #-1,D1                        Job utilisateur=job courant.
USE_THG   MOVEQ     #$28,D0                       Code pour appel  SMS.UTHG.
DO_THING  MOVEQ     #-1,D3                        Temporisation infinie.
DO_THG    MOVE.L    A4,-(SP)                      | Sauvegarder le contexte.
          MOVEM.L   D0/A0,-(SP)                   |
          BSR.S     SEARCH                        Chercher le vecteur "THING".
          MOVEM.L   (SP)+,D0/A0                   Restaurer ptr nom est code.
          BNE.S     DONE                          Si erreur pas d'appel.
          JSR       (A4)                          Appel au vecteur "THING".
DONE      MOVEA.L   (SP)+,A4                      Restaurer contexte.
          TST.L     D0                            Positionner CCR.
          RTS                                     Retour.

********************************************************************************
* Routine de recherche de la chose "THING":
* ========================================
*
* Paramtres en entre: nant
* ~~~~~~~~~~~~~~~~~~~~
* Paramtres en sortie: A0.L=Adresse de "THING" (si D0=0),
* ~~~~~~~~~~~~~~~~~~~~  A4.L=Adresse de la routine "TH_ENTRY",
*                       D0.L=Code erreur (0: pas d'erreur, -19: non implment),
*
* Registres modifis  : D0, A0, A4.
* ~~~~~~~~~~~~~~~~~~

SEARCH    MOVEM.L   D1/D2,-(SP)                   Sauver le contexte.
          MOVEQ     #0,D0                         | Prendre les informations
          TRAP      #1                            | sur le systme.
          MOVEQ     #-19,D0                       Code erreur "non implment".
          LEA       $B8(A0),A0                    Pointeur sur liste des choses.
          MOVE.L    A0,D1                         Pointeur nul ?
          BEQ.S     SEARCH3                       Si oui, retour (pas de chose).
SEARCH1   MOVE.L    (A0),D1                       D1=Adresse du linkage block.
          BEQ.S     SEARCH2                       Si dernire chose, fin
          MOVEA.L   D1,A0                         | sinon poursuivre la recher-
          BRA.S     SEARCH1                       | che avec la chose suivante.
SEARCH2   MOVEA.L   16(A0),A0                     Pointeur sur chose elle-mme.
          CMPI.L    #'THG%',(A0)                  Est-ce bien une chose ?
          BNE.S     SEARCH3                       Si non, retour avec erreur.
          CMPI.L    #-1,4(A0)                     Est-ce la chose "THING" ?
          BNE.S     SEARCH3                       Si non, retour avec erreur.
          MOVEA.L   8(A0),A4                      Prendre le vecteur TH_ENTRY.
          MOVEQ     #0,D0                         Pas d'erreur.
SEARCH3   MOVEM.L   (SP)+,D1/D2                   Restaurer le contexte.
          TST.L     D0                            Positionner CCR.
          RTS                                     Retour.

********************************************************************************
* Donnes diverses:
* ~~~~~~~~~~~~~~~~

* Nom de la chose "extensions Menu":
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

MENUS     dc.w      5
          dc.b      'Menus',0

* Titre du menu de FSEL:
* ~~~~~~~~~~~~~~~~~~~~~

TITLE     dc.w      13
          dc.b      'Choose a file',0

* Nom du priphrique console pour ouverture des fentres:
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

CONSOLE   dc.w      11
          dc.b      'con_2x1a0x0',0

* Nom du job:
* ~~~~~~~~~~~

JOBNAME1  dc.w      14
          dc.b      'EMACS sub-menu'

* Table des pointeurs sur les dfinitions des sous-menus:
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

MENU_LIST dc.w      FICHIERS-MENU_LIST
          dc.w      EDITION-MENU_LIST
          dc.w      REGIONS-MENU_LIST
          dc.w      CHERCHE-MENU_LIST
          dc.w      MOUVEMENT-MENU_LIST
          dc.w      TAMPONS-MENU_LIST
          dc.w      FENETRES-MENU_LIST
          dc.w      MODES-MENU_LIST
          dc.w      COMMANDE-MENU_LIST
          dc.w      AIDE-MENU_LIST
          dc.w      CONTEXT-MENU_LIST

********************************************************************************
* Sous-menu "Fichiers":
* ~~~~~~~~~~~~~~~~~~~~

          dc.w      13                  Numro du loose item "stick/unstick".

          dc.w      FIC_CMDS-FICHIERS   Ptr vers table des ptr sur commandes.

FICHIERS  dc.l      $300                working definition length
          dc.l      $60                 status area length
          dc.b      -1                  -1 no mode change, 0/8 force mode 4/8
          dc.b      0                   -1 absolute position, 0 pointer relative
          dc.w      0,0                 absolute initial position (set_org = -1)

* Main window definition:
* ~~~~~~~~~~~~~~~~~~~~~~

          dc.w      176                 default window x size
          dc.w      164                                y size
          dc.w      134                 initial pointer x position
          dc.w      3                                   y position
          dc.b      0                   MSbit clear to clear window
          dc.b      2                   shadow depth
          dc.w      1                   border width
          dc.w      7                   border colour
          dc.w      0                   paper colour
          dc.w      _hand_spr-*         pointer to pointer sprite

* Menu item attributes:

          dc.w      1                   current item border width
          dc.w      4                                border colour

* Menu item unavailable:

          dc.w      0                   background colour
          dc.w      2                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item available:

          dc.w      0                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item selected:

          dc.w      2                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

          dc.w      0                   pointer to help window

* Base of repeated part of window definition:

          dc.w      176                 x (min.) size for this layout
          dc.w      164                 y (min.) size for this layout

* Pointers to definition lists:

          dc.w      FICH_IL-*           information sub-windows
          dc.w      FICH_LL-*           loose menu items
          dc.w      0                   application sub-windows

          dc.w      -1                  end flag

* Information sub-window definition list:
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

* Information sub-window n 0

FICH_IL   dc.w      168                 sub-window x size
          dc.w      118                 sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      14                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      FICH_OL0-*          pointer to information object list

* Information sub-window n 1

          dc.w      168                 sub-window x size
          dc.w      14                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      133                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      FICH_OL1-*          pointer to information object list

* Information sub-window n 2

          dc.w      168                 sub-window x size
          dc.w      14                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      148                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      FICH_OL2-*          pointer to information object list

* Information sub-window n 3

          dc.w      110                 sub-window x size
          dc.w      11                  sub-window y size
          dc.w      42                  sub-window x origin
          dc.w      1                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      100                 paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 4

          dc.w      38                  sub-window x size
          dc.w      12                  sub-window y size
          dc.w      66                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      FICH_OL4-*          pointer to information object list

          dc.w      -1                  end flag

* Information sub-window n 0 object list:

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

FICH_OL0  dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FIC_OB1-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FIC_OB2-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FIC_OB3-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FIC_OB4-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      54                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FIC_OB5-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      67                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FIC_OB6-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      80                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FIC_OB7-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      93                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FIC_OB8-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      106                        y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FIC_OB9-*           pointer to object

          dc.w      -1                  end flag

* Information sub-window n 1 object list:

FICH_OL1  dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 2 object list:

FICH_OL2  dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FIC_OB11-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 4 object list:

FICH_OL4  dc.w      34                  object x size
          dc.w      10                         y size
          dc.w      4                          x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FIC_OB12-*          pointer to object

          dc.w      -1                  end flag

* Loose menu item list:
* ~~~~~~~~~~~~~~~~~~~~

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

* Loose menu item n 0

FICH_LL   dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      15                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'R'                 selection keystroke
          dc.w      FIC_OB13-*          pointer to object
          dc.w      0                   item number
          dc.w      SEND_FNAM-*         pointer to action routine

* Loose menu item n 1

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      28                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'F'                 selection keystroke
          dc.w      FIC_OB14-*          pointer to object
          dc.w      1                   item number
          dc.w      SEND_FNAM-*         pointer to action routine

* Loose menu item n 2

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      41                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'V'                 selection keystroke
          dc.w      FIC_OB15-*          pointer to object
          dc.w      2                   item number
          dc.w      SEND_FNAM-*         pointer to action routine

* Loose menu item n 3

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      54                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'I'                 selection keystroke
          dc.w      FIC_OB16-*          pointer to object
          dc.w      3                   item number
          dc.w      SEND_FNAM-*         pointer to action routine

* Loose menu item n 4

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      67                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'S'                 selection keystroke
          dc.w      FIC_OB17-*          pointer to object
          dc.w      4                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 5

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      80                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'W'                 selection keystroke
          dc.w      FIC_OB18-*          pointer to object
          dc.w      5                   item number
          dc.w      SEND_FNAM-*         pointer to action routine

* Loose menu item n 6

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      93                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'A'                 selection keystroke
          dc.w      FIC_OB19-*          pointer to object
          dc.w      6                   item number
          dc.w      SEND_FNAM-*         pointer to action routine

* Loose menu item n 7

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      106                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -3                  object type
          dc.b      'N'                 selection keystroke
          dc.w      FIC_OB20-*          pointer to object
          dc.w      7                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 8

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      119                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -18                 object type
          dc.b      'E'                 selection keystroke
          dc.w      FIC_OB21-*          pointer to object
          dc.w      8                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 9

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      134                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'P'                 selection keystroke
          dc.w      FIC_OB22-*          pointer to object
          dc.w      9                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 10

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      149                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'Q'                 selection keystroke
          dc.w      FIC_OB23-*          pointer to object
          dc.w      10                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 10

          dc.w      18                  hit area   x size
          dc.w      10                             y size
          dc.w      154                            x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      3                   selection keystroke
          dc.w      ESC_OBJ-*           pointer to object
          dc.w      11                  item number
          dc.w      EVENT0-*            pointer to action routine

* Loose menu item n 12

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      4                              x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      5                   selection keystroke
          dc.w      MOVE_SPR-*          pointer to object
          dc.w      12                  item number
          dc.w      EVENT-*             pointer to action routine

* Loose menu item n 13

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      24                             x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      236                 selection keystroke
          dc.w      UNST_SPR-*          pointer to object
          dc.w      13                  item number
          dc.w      STICK-*             pointer to action routine

          dc.w      -1                  end flag

FIC_CMDS  dc.w      FIC_CMD1-FIC_CMDS
          dc.w      FIC_CMD2-FIC_CMDS
          dc.w      FIC_CMD3-FIC_CMDS
          dc.w      FIC_CMD4-FIC_CMDS
          dc.w      FIC_CMD5-FIC_CMDS
          dc.w      FIC_CMD6-FIC_CMDS
          dc.w      FIC_CMD7-FIC_CMDS
          dc.w      FIC_CMD8-FIC_CMDS
          dc.w      FIC_CMD9-FIC_CMDS
          dc.w      FIC_CMD10-FIC_CMDS
          dc.w      FIC_CMD11-FIC_CMDS

* Object list:
* ~~~~~~~~~~~

* Object n 1

FIC_OB1   dc.w      4
          dc.b      '^X^R'

FIC_CMD1  dc.w      9
          dc.b      'read-file',0

* Object n 2

FIC_OB2   dc.w      4
          dc.b      '^X^F'

FIC_CMD2  dc.w      9
          dc.b      'find-file',0

* Object n 3

FIC_OB3   dc.w      4
          dc.b      '^X^V'

FIC_CMD3  dc.w      9
          dc.b      'view-file',0

* Object n 4

FIC_OB4   dc.w      4
          dc.b      '^X^I'

FIC_CMD4  dc.w      11
          dc.b      'insert-file',0

* Object n 5

FIC_OB5   dc.w      4
          dc.b      '^X^S'

FIC_CMD5  dc.w      9
          dc.b      'save-file',0

* Object n 6

FIC_OB6   dc.w      4
          dc.b      '^X^W'

FIC_CMD6  dc.w      10
          dc.b      'write-file'

* Object n 7

FIC_OB7   dc.w      4
          dc.b      '^X^A'

FIC_CMD7  dc.w      11
          dc.b      'append-file',0

* Object n 8

FIC_OB8   dc.w      4
          dc.b      '^X N'

FIC_CMD8  dc.w      16
          dc.b      'change-file-name'

* Object n 9

FIC_OB9   dc.w      4
          dc.b      'e. Z'

FIC_CMD9  dc.w      10
          dc.b      'quick-exit'

FIC_CMD10 dc.w      12
          dc.b      'print-buffer'

* Object n 11

FIC_OB11  dc.w      4
          dc.b      '^X^Q'

FIC_CMD11 dc.w      10
          dc.b      'exit-emacs'

* Object n 12

FIC_OB12  dc.w      5
          dc.b      'Files',0

* Object n 13

FIC_OB13  dc.w      22
          dc.b      'Read file (same buff.)'

* Object n 14

FIC_OB14  dc.w      22
          dc.b      'Find file (new buffer)'

* Object n 15

FIC_OB15  dc.w      22
          dc.b      'View file (no editing)'

* Object n 16

FIC_OB16  dc.w      13
          dc.b      'Insert a file',0

* Object n 17

FIC_OB17  dc.w      17
          dc.b      'Save current file',0

* Object n 18

FIC_OB18  dc.w      21
          dc.b      'Write file (new name)',0

* Object n 19

FIC_OB19  dc.w      11
          dc.b      'Append file',0

* Object n 20

FIC_OB20  dc.w      19
          dc.b      'Rename current file',0

* Object n 21

FIC_OB21  dc.w      21
          dc.b      'Save buffers and exit',0

* Object n 22

FIC_OB22  dc.w      5
          dc.b      'Print',0

* Object n 23

FIC_OB23  dc.w      21
          dc.b      'Quit MicroEMACS v4.00',0

********************************************************************************
* Sous-menu "Edit":
* ~~~~~~~~~~~~~~~~

          dc.w      18                  Numro du loose item "stick/unstick".

          dc.w      EDT_CMDS-EDITION    Ptr vers table des ptr sur commandes.

EDITION   dc.l      $410                working definition length
          dc.l      $70                 status area length
          dc.b      0                   -1 no mode change, 0/8 force mode 4/8
          dc.b      0                   -1 absolute position, 0 pointer relative
          dc.w      0,0                 absolute initial position (set_org = -1)

* Main window definition:
* ~~~~~~~~~~~~~~~~~~~~~~

          dc.w      176                 default window x size
          dc.w      244                                y size
          dc.w      134                 initial pointer x position
          dc.w      3                                   y position
          dc.b      0                   MSbit clear to clear window
          dc.b      2                   shadow depth
          dc.w      1                   border width
          dc.w      7                   border colour
          dc.w      0                   paper colour
          dc.w      _hand_spr-*         pointer to pointer sprite

* Menu item attributes:

          dc.w      1                   current item border width
          dc.w      4                                border colour

* Menu item unavailable:

          dc.w      0                   background colour
          dc.w      2                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item available:

          dc.w      0                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item selected:

          dc.w      2                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

          dc.w      0                   pointer to help window

* Base of repeated part of window definition

          dc.w      176                 x (min.) size for this layout
          dc.w      244                 y (min.) size for this layout

* Pointers to definition lists:

          dc.w      EDT_IL-*            information sub-windows
          dc.w      EDT_LL-*            loose menu items
          dc.w      0                   application sub-windows

          dc.w      -1                  end flag

* Information sub-window definition list:
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

* Information sub-window n 0

EDT_IL    dc.w      168                 sub-window x size
          dc.w      92                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      14                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      EDT_OL0-*           pointer to information object list

* Information sub-window n 1

          dc.w      168                 sub-window x size
          dc.w      40                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      107                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      EDT_OL1-*           pointer to information object list

* Information sub-window n 2

          dc.w      168                 sub-window x size
          dc.w      79                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      148                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      EDT_OL2-*           pointer to information object list

* Information sub-window n 3

          dc.w      168                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      230                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      EDT_OL3-*           pointer to information object list

* Information sub-window n 4

          dc.w      110                 sub-window x size
          dc.w      13                  sub-window y size
          dc.w      42                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      100                 paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 5

          dc.w      32                  sub-window x size
          dc.w      12                  sub-window y size
          dc.w      68                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      EDT_OL5-*           pointer to information object list

          dc.w      -1                  end flag

* Information sub-window n 0 object list:

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

EDT_OL0   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      EDT_OB1-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      EDT_OB2-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      EDT_OB3-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      EDT_OB4-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      54                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      EDT_OB5-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      67                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      EDT_OB6-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      80                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      EDT_OB7-*           pointer to object

          dc.w      -1                  end flag

* Information sub-window n 1 object list:

EDT_OL1   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      EDT_OB8-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      EDT_OB9-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      EDT_OB10-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 2 object list:

EDT_OL2   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      54                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      67                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 3 object list:

EDT_OL3   dc.w      118                 object x size
          dc.w      10                         y size
          dc.w      2                          x origin
          dc.w      1                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      ARG_OBJ-*           pointer to object

          dc.w      -1                  end flag

* Information sub-window n 5 object list:

EDT_OL5   dc.w      24                  object x size
          dc.w      10                         y size
          dc.w      4                          x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      EDT_OB18-*          pointer to object

          dc.w      -1                  end flag

* Loose menu item list:
* ~~~~~~~~~~~~~~~~~~~~

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

* Loose menu item n 0

EDT_LL    dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      15                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'Q'                 selection keystroke
          dc.w      EDT_OB19-*          pointer to object
          dc.w      0                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 1

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      28                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'U'                 selection keystroke
          dc.w      EDT_OB20-*          pointer to object
          dc.w      1                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 2

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      41                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'L'                 selection keystroke
          dc.w      EDT_OB21-*          pointer to object
          dc.w      2                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 3

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      54                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'I'                 selection keystroke
          dc.w      EDT_OB22-*          pointer to object
          dc.w      3                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 4

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      67                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'K'                 selection keystroke
          dc.w      EDT_OB23-*          pointer to object
          dc.w      4                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 5

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      80                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'D'                 selection keystroke
          dc.w      EDT_OB24-*          pointer to object
          dc.w      5                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 6

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      93                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'F'                 selection keystroke
          dc.w      EDT_OB25-*          pointer to object
          dc.w      6                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 7

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      108                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -11                 object type
          dc.b      'O'                 selection keystroke
          dc.w      EDT_OB26-*          pointer to object
          dc.w      7                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 8

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      121                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -7                  object type
          dc.b      'N'                 selection keystroke
          dc.w      EDT_OB27-*          pointer to object
          dc.w      8                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 9

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      134                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'E'                 selection keystroke
          dc.w      EDT_OB28-*          pointer to object
          dc.w      9                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 10

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      149                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'A'                 selection keystroke
          dc.w      EDT_OB29-*          pointer to object
          dc.w      10                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 11

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      162                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -12                 object type
          dc.b      'B'                 selection keystroke
          dc.w      EDT_OB30-*          pointer to object
          dc.w      11                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 12

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      175                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -13                 object type
          dc.b      'V'                 selection keystroke
          dc.w      EDT_OB31-*          pointer to object
          dc.w      12                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 13

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      188                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -13                 object type
          dc.b      'R'                 selection keystroke
          dc.w      EDT_OB32-*          pointer to object
          dc.w      13                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 14

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      201                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -3                  object type
          dc.b      'S'                 selection keystroke
          dc.w      EDT_OB33-*          pointer to object
          dc.w      14                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 15

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      214                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -18                 object type
          dc.b      'T'                 selection keystroke
          dc.w      EDT_OB34-*          pointer to object
          dc.w      15                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 16

          dc.w      18                  hit area   x size
          dc.w      10                             y size
          dc.w      154                            x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      3                   selection keystroke
          dc.w      ESC_OBJ-*           pointer to object
          dc.w      16                  item number
          dc.w      EVENT0-*            pointer to action routine

* Loose menu item n 17

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      4                              x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      5                   selection keystroke
          dc.w      MOVE_SPR-*          pointer to object
          dc.w      17                  item number
          dc.w      EVENT-*             pointer to action routine

* Loose menu item n 18

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      24                             x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      236                 selection keystroke
          dc.w      UNST_SPR-*          pointer to object
          dc.w      18                  item number
          dc.w      STICK-*             pointer to action routine

* Loose menu item n 10

          dc.w      44                  hit area   x size
          dc.w      10                             y size
          dc.w      126                            x origin
          dc.w      231                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      '.'                 selection keystroke
          dc.w      FAKE_ARG-*          pointer to object
          dc.w      19                  item number
          dc.w      CHANGE-*            pointer to action routine

          dc.w      -1                  end flag

EDT_CMDS  dc.w      EDT_CMD1-EDT_CMDS
          dc.w      EDT_CMD2-EDT_CMDS
          dc.w      EDT_CMD3-EDT_CMDS
          dc.w      EDT_CMD4-EDT_CMDS
          dc.w      EDT_CMD5-EDT_CMDS
          dc.w      EDT_CMD6-EDT_CMDS
          dc.w      EDT_CMD7-EDT_CMDS
          dc.w      EDT_CMD8-EDT_CMDS
          dc.w      EDT_CMD9-EDT_CMDS
          dc.w      EDT_CMD10-EDT_CMDS
          dc.w      EDT_CMD11-EDT_CMDS
          dc.w      EDT_CMD12-EDT_CMDS
          dc.w      EDT_CMD13-EDT_CMDS
          dc.w      EDT_CMD14-EDT_CMDS
          dc.w      EDT_CMD15-EDT_CMDS
          dc.w      EDT_CMD16-EDT_CMDS

* Object list:
* ~~~~~~~~~~~

* Object n 1

EDT_OB1   dc.w      4
          dc.b      '  ^Q'

EDT_CMD1  dc.w      15
          dc.b      'quote-character',0

* Object n 2

EDT_OB2   dc.w      4
          dc.b      'e. U'

EDT_CMD2  dc.w      15
          dc.b      'case-word-upper',0

* Object n 3

EDT_OB3   dc.w      4
          dc.b      'e. L'

EDT_CMD3  dc.w      15
          dc.b      'case-word-lower',0

* Object n 4

EDT_OB4   dc.w      4
          dc.b      'e. C'

EDT_CMD4  dc.w      20
          dc.b      'case-word-capitalize'

* Object n 5

EDT_OB5   dc.w      4
          dc.b      '  ^K'

EDT_CMD5  dc.w      19
          dc.b      'kill-to-end-of-line',0

* Object n 6

EDT_OB6   dc.w      4
          dc.b      'e.^W'

EDT_CMD6  dc.w      14
          dc.b      'kill-paragraph'

* Object n 7

EDT_OB7   dc.w      4
          dc.b      'e. Q'

EDT_CMD7  dc.w      14
          dc.b      'fill-paragraph'

* Object n 8

EDT_OB8   dc.w      4
          dc.b      '^X^H'

EDT_CMD8  dc.w      4
          dc.b      'undo'

* Object n 9

EDT_OB9   dc.w      4
          dc.b      '^X U'

EDT_CMD9  dc.w      10
          dc.b      'list-undos'

* Object n 10

EDT_OB10  dc.w      4
          dc.b      'e.^U'

EDT_CMD10 dc.w      12
          dc.b      'delete-undos'

EDT_CMD11 dc.w      10
          dc.b      'add-abbrev'

EDT_CMD12 dc.w      13
          dc.b      'delete-abbrev',0

EDT_CMD13 dc.w      14
          dc.b      'define-abbrevs'

EDT_CMD14 dc.w      16
          dc.b      'describe-abbrevs'

EDT_CMD15 dc.w      14
          dc.b      'insert-abbrevs'

EDT_CMD16 dc.w      12
          dc.b      'kill-abbrevs'

* Object n 18

EDT_OB18  dc.w      4
          dc.b      'Edit',0

* Object n 19

EDT_OB19  dc.w      15
          dc.b      'Quote character',0

* Object n 20

EDT_OB20  dc.w      15
          dc.b      'Upper case word',0

* Object n 21

EDT_OB21  dc.w      15
          dc.b      'Lower case word',0

* Object n 22

EDT_OB22  dc.w      18
          dc.b      'Initial capitalize'

* Object n 23

EDT_OB23  dc.w      12
          dc.b      'Kill forward'

* Object n 24

EDT_OB24  dc.w      16
          dc.b      'Delete paragraph'

* Object n 25

EDT_OB25  dc.w      22
          dc.b      'Fill current paragraph'

* Object n 26

EDT_OB26  dc.w      19
          dc.b      'Undo last operation',0

* Object n 27

EDT_OB27  dc.w      21
          dc.b      'List undo information',0

* Object n 28

EDT_OB28  dc.w      20
          dc.b      'Erase all undo info.'

* Object n 29

EDT_OB29  dc.w      19
          dc.b      'Add an abbreviation',0

* Object n 30

EDT_OB30  dc.w      22
          dc.b      'Delete an abbreviation'

* Object n 31

EDT_OB31  dc.w      20
          dc.b      'Define abbreviations'

* Object n 32

EDT_OB32  dc.w      22
          dc.b      'List all abbreviations'

* Object n 33

EDT_OB33  dc.w      20
          dc.b      'Insert abbreviations'

* Object n 34

EDT_OB34  dc.w      22
          dc.b      'Kill all abbreviations'

********************************************************************************
* Sous-menu "Rgions":
* ~~~~~~~~~~~~~~~~~~~

          dc.w      18                  Numro du loose item "stick/unstick".

          dc.w      REG_CMDS-REGIONS    Ptr vers table des ptr sur commandes.

REGIONS   dc.l      $3F0                working definition length
          dc.l      $70                 status area length
          dc.b      0                   -1 no mode change, 0/8 force mode 4/8
          dc.b      0                   -1 absolute position, 0 pointer relative
          dc.w      0,0                 absolute initial position

* Main window definition:
* ~~~~~~~~~~~~~~~~~~~~~~

          dc.w      176                 default window x size
          dc.w      242                                y size
          dc.w      134                 initial pointer x position
          dc.w      3                                   y position
          dc.b      0                   MSbit clear to clear window
          dc.b      2                   shadow depth
          dc.w      1                   border width
          dc.w      7                   border colour
          dc.w      0                   paper colour
          dc.w      _hand_spr-*         pointer to pointer sprite

* Menu item attributes:

          dc.w      1                   current item border width
          dc.w      4                                border colour

* Menu item unavailable:

          dc.w      0                   background colour
          dc.w      2                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item available:

          dc.w      0                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item selected:

          dc.w      2                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

          dc.w      0                   pointer to help window

* Base of repeated part of window definition

          dc.w      176                 x (min.) size for this layout
          dc.w      242                 y (min.) size for this layout

* Pointers to definition lists:

          dc.w      REG_IL-*            information sub-windows
          dc.w      REG_LL-*            loose menu items
          dc.w      0                   application sub-windows

          dc.w      -1                  end flag

* Information sub-window definition list:
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

* Information sub-window n 0

REG_IL    dc.w      168                 sub-window x size
          dc.w      66                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      14                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      REG_OL0-*           pointer to information object list

* Information sub-window n 1

          dc.w      168                 sub-window x size
          dc.w      144                 sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      81                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      REG_OL1-*           pointer to information object list

* Information sub-window n 2

          dc.w      168                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      228                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      REG_OL2-*           pointer to information object list

* Information sub-window n 3

          dc.w      110                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      42                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      100                 paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 4

          dc.w      50                  sub-window x size
          dc.w      12                  sub-window y size
          dc.w      60                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      REG_OL4-*           pointer to information object list

          dc.w      -1                  end flag

* Information sub-window n 0 object list:

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

REG_OL0   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      REG_OB1-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      REG_OB2-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      REG_OB3-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      54                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 1 object list:

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

REG_OL1   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      REG_OB6-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      REG_OB7-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      REG_OB8-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      REG_OB9-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      54                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      REG_OB10-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      67                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      REG_OB11-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      80                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      REG_OB12-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      93                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      REG_OB13-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      106                        y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      REG_OB14-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      119                        y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      REG_OB15-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      132                        y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 2 object list:

REG_OL2   dc.w      120                 object x size
          dc.w      10                         y size
          dc.w      2                          x origin
          dc.w      1                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      ARG_OBJ-*           pointer to object

          dc.w      -1                  end flag

* Information sub-window n 4 object list:

REG_OL4   dc.w      46                  object x size
          dc.w      10                         y size
          dc.w      4                          x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      REG_OB18-*          pointer to object

          dc.w      -1                  end flag

* Loose menu item list:
* ~~~~~~~~~~~~~~~~~~~~

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

* Loose menu item n 0

REG_LL    dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      15                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'C'                 selection keystroke
          dc.w      REG_OB19-*          pointer to object
          dc.w      0                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 1

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      28                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'M'                 selection keystroke
          dc.w      REG_OB20-*          pointer to object
          dc.w      1                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 2

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      41                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'P'                 selection keystroke
          dc.w      REG_OB21-*          pointer to object
          dc.w      2                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 3

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      54                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -9                  object type
          dc.b      'S'                 selection keystroke
          dc.w      REG_OB22-*          pointer to object
          dc.w      3                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 4

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      67                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -11                 object type
          dc.b      'A'                 selection keystroke
          dc.w      REG_OB23-*          pointer to object
          dc.w      4                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 5

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      82                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'U'                 selection keystroke
          dc.w      REG_OB24-*          pointer to object
          dc.w      5                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 6

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      95                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'L'                 selection keystroke
          dc.w      REG_OB25-*          pointer to object
          dc.w      6                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 7

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      108                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'E'                 selection keystroke
          dc.w      REG_OB26-*          pointer to object
          dc.w      7                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 8

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      121                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'D'                 selection keystroke
          dc.w      REG_OB27-*          pointer to object
          dc.w      8                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 9

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      134                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'N'                 selection keystroke
          dc.w      REG_OB28-*          pointer to object
          dc.w      9                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 10

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      147                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -7                  object type
          dc.b      'F'                 selection keystroke
          dc.w      REG_OB29-*          pointer to object
          dc.w      10                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 11

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      160                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'I'                 selection keystroke
          dc.w      REG_OB30-*          pointer to object
          dc.w      11                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 12

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      173                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -8                  object type
          dc.b      'R'                 selection keystroke
          dc.w      REG_OB31-*          pointer to object
          dc.w      12                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 13

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      186                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'T'                 selection keystroke
          dc.w      REG_OB32-*          pointer to object
          dc.w      13                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 14

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      199                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -2                  object type
          dc.b      'O'                 selection keystroke
          dc.w      REG_OB33-*          pointer to object
          dc.w      14                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 15

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      212                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -8                  object type
          dc.b      'W'                 selection keystroke
          dc.w      REG_OB34-*          pointer to object
          dc.w      15                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 16

          dc.w      18                  hit area   x size
          dc.w      10                             y size
          dc.w      154                            x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      3                   selection keystroke
          dc.w      ESC_OBJ-*           pointer to object
          dc.w      16                  item number
          dc.w      EVENT0-*            pointer to action routine

* Loose menu item n 17

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      4                              x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      5                   selection keystroke
          dc.w      MOVE_SPR-*          pointer to object
          dc.w      17                  item number
          dc.w      EVENT-*             pointer to action routine

* Loose menu item n 18

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      24                             x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      236                 selection keystroke
          dc.w      UNST_SPR-*          pointer to object
          dc.w      18                  item number
          dc.w      STICK-*             pointer to action routine

* Loose menu item n 19

          dc.w      44                  hit area   x size
          dc.w      10                             y size
          dc.w      126                            x origin
          dc.w      229                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      '.'                 selection keystroke
          dc.w      FAKE_ARG-*          pointer to object
          dc.w      19                  item number
          dc.w      CHANGE-*            pointer to action routine

          dc.w      -1                  end flag

REG_CMDS  dc.w      REG_CMD1-REG_CMDS
          dc.w      REG_CMD2-REG_CMDS
          dc.w      REG_CMD3-REG_CMDS
          dc.w      REG_CMD4-REG_CMDS
          dc.w      REG_CMD5-REG_CMDS
          dc.w      REG_CMD6-REG_CMDS
          dc.w      REG_CMD7-REG_CMDS
          dc.w      REG_CMD8-REG_CMDS
          dc.w      REG_CMD9-REG_CMDS
          dc.w      REG_CMD10-REG_CMDS
          dc.w      REG_CMD11-REG_CMDS
          dc.w      REG_CMD12-REG_CMDS
          dc.w      REG_CMD13-REG_CMDS
          dc.w      REG_CMD14-REG_CMDS
          dc.w      REG_CMD15-REG_CMDS
          dc.w      REG_CMD16-REG_CMDS

* Object list:
* ~~~~~~~~~~~

* Object n 1

REG_OB1   dc.w      4
          dc.b      'e. W'

REG_CMD1  dc.w      11
          dc.b      'copy-region',0

* Object n 2

REG_OB2   dc.w      4
          dc.b      '  ^W'

REG_CMD2  dc.w      11
          dc.b      'kill-region',0

* Object n 3

REG_OB3   dc.w      4
          dc.b      '  ^Y'

REG_CMD3  dc.w      4
          dc.b      'yank'

REG_CMD4  dc.w      15
          dc.b      'region-to-scrap',0

REG_CMD5  dc.w      12
          dc.b      'insert-scrap'

* Object n 6

REG_OB6   dc.w      4
          dc.b      '^X^U'

REG_CMD6  dc.w      17
          dc.b      'case-region-upper',0

* Object n 7

REG_OB7   dc.w      4
          dc.b      '^X^L'

REG_CMD7  dc.w      17
          dc.b      'case-region-lower',0

* Object n 8

REG_OB8   dc.w      4
          dc.b      '^X^E'

REG_CMD8  dc.w      12
          dc.b      'entab-region'

* Object n 9

REG_OB9   dc.w      4
          dc.b      '^X^D'

REG_CMD9  dc.w      12
          dc.b      'detab-region'

* Object n 10

REG_OB10  dc.w      4
          dc.b      '^X <'

REG_CMD10 dc.w      16
          dc.b      'narrow-to-region'

* Object n 11

REG_OB11  dc.w      4
          dc.b      '^X >'

REG_CMD11 dc.w      17
          dc.b      'widen-from-region',0

* Object n 12

REG_OB12  dc.w      4
          dc.b      'e. )'

REG_CMD12 dc.w      13
          dc.b      'indent-region',0

* Object n 13

REG_OB13  dc.w      4
          dc.b      'e. ('

REG_CMD13 dc.w      13
          dc.b      'undent-region',0

* Object n 14

REG_OB14  dc.w      4
          dc.b      '^X^T'

REG_CMD14 dc.w      11
          dc.b      'trim-region',0

* Object n 15

REG_OB15  dc.w      4
          dc.b      'e.^C'

REG_CMD15 dc.w      11
          dc.b      'count-words',0

REG_CMD16 dc.w      11
          dc.b      'select-word',0

* Object n 18

REG_OB18  dc.w      7
          dc.b      'Regions',0

* Object n 19

REG_OB19  dc.w      19
          dc.b      'Copy to kill buffer',0

* Object n 20

REG_OB20  dc.w      19
          dc.b      'Move to kill buffer',0

* Object n 21

REG_OB21  dc.w      22
          dc.b      'Paste from kill buffer'

* Object n 22

REG_OB22  dc.w      13
          dc.b      'Copy to scrap',0

* Object n 23

REG_OB23  dc.w      12
          dc.b      'Insert scrap'

* Object n 24

REG_OB24  dc.w      17
          dc.b      'Upper case region',0

* Object n 25

REG_OB25  dc.w      17
          dc.b      'Lower case region',0

* Object n 26

REG_OB26  dc.w      12
          dc.b      'Entab region'

* Object n 27

REG_OB27  dc.w      12
          dc.b      'Detab region'

* Object n 28

REG_OB28  dc.w      16
          dc.b      'Narrow to region'

* Object n 29

REG_OB29  dc.w      17
          dc.b      'Widen from region',0

* Object n 30

REG_OB30  dc.w      13
          dc.b      'Indent region',0

* Object n 31

REG_OB31  dc.w      13
          dc.b      'Undent region',0

* Object n 32

REG_OB32  dc.w      11
          dc.b      'Trim region',0

* Object n 33

REG_OB33  dc.w      21
          dc.b      'Count words in region',0

* Object n 34

REG_OB34  dc.w      21
          dc.b      'Select word as region',0

********************************************************************************
* Sous-menu "Recherche":
* ~~~~~~~~~~~~~~~~~~~~~

          dc.w      14                  Numro du loose item "stick/unstick".

          dc.w      CHE_CMDS-CHERCHE    Ptr vers table des ptr sur commandes.

CHERCHE   dc.l      $350                working definition length
          dc.l      $60                 status area length
          dc.b      0                   -1 no mode change, 0/8 force mode 4/8
          dc.b      0                   -1 absolute position, 0 pointer relative
          dc.w      0,0                 absolute initial position

* Main window definition:
* ~~~~~~~~~~~~~~~~~~~~~~

          dc.w      176                 default window x size
          dc.w      190                                y size
          dc.w      134                 initial pointer x position
          dc.w      3                                   y position
          dc.b      0                   MSbit clear to clear window
          dc.b      2                   shadow depth
          dc.w      1                   border width
          dc.w      7                   border colour
          dc.w      0                   paper colour
          dc.w      _hand_spr-*         pointer to pointer sprite

* Menu item attributes:

          dc.w      1                   current item border width
          dc.w      4                                border colour

* Menu item unavailable:

          dc.w      0                   background colour
          dc.w      2                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item available:

          dc.w      0                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item selected:

          dc.w      2                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

          dc.w      0                   pointer to help window

* Base of repeated part of window definition

          dc.w      176                 x (min.) size for this layout
          dc.w      190                 y (min.) size for this layout

* Pointers to definition lists:

          dc.w      CHE_IL-*            information sub-windows
          dc.w      CHE_LL-*            loose menu items
          dc.w      0                   application sub-windows

          dc.w      -1                  end flag

* Information sub-window definition list:
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

* Information sub-window n 0

CHE_IL    dc.w      168                 sub-window x size
          dc.w      118                 sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      14                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      CHE_OL0-*           pointer to information object list

* Information sub-window n 1

          dc.w      168                 sub-window x size
          dc.w      40                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      133                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      CHE_OL1-*           pointer to information object list

* Information sub-window n 2

          dc.w      110                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      42                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      100                 paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 3

          dc.w      42                  sub-window x size
          dc.w      12                  sub-window y size
          dc.w      64                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      CHE_OL3-*           pointer to information object list

* Information sub-window n 4

          dc.w      168                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      176                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      CHE_OL4-*           pointer to information object list

          dc.w      -1                  end flag

* Information sub-window n 0 object list:

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

CHE_OL0   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink color
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      CHE_OB1-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      CHE_OB2-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      CHE_OB3-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      CHE_OB4-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      54                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      CHE_OB5-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      67                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      CHE_OB6-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      80                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      CHE_OB7-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      93                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      CHE_OB8-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      106                        y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 1 object list:

CHE_OL1   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink color
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 3 object list:

CHE_OL3   dc.w      40                  object x size
          dc.w      10                         y size
          dc.w      2                          x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      CHE_OB13-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 4 object list:

CHE_OL4   dc.w      120                 object x size
          dc.w      10                         y size
          dc.w      2                          x origin
          dc.w      1                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      ARG_OBJ-*           pointer to object

          dc.w      -1                  end flag

* Loose menu item list:
* ~~~~~~~~~~~~~~~~~~~~

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

* Loose menu item n 0

CHE_LL    dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      15                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'S'                 selection keystroke
          dc.w      CHE_OB15-*          pointer to object
          dc.w      0                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 1

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      28                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -8                  object type
          dc.b      'B'                 selection keystroke
          dc.w      CHE_OB16-*          pointer to object
          dc.w      1                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 2

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      41                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'N'                 selection keystroke
          dc.w      CHE_OB17-*          pointer to object
          dc.w      2                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 3

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      54                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'P'                 selection keystroke
          dc.w      CHE_OB18-*          pointer to object
          dc.w      3                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 4

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      67                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'I'                 selection keystroke
          dc.w      CHE_OB19-*          pointer to object
          dc.w      4                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 5

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      80                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -3                  object type
          dc.b      'C'                 selection keystroke
          dc.w      CHE_OB20-*          pointer to object
          dc.w      5                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 6

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      93                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -12                 object type
          dc.b      'R'                 selection keystroke
          dc.w      CHE_OB21-*          pointer to object
          dc.w      6                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 7

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      106                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -10                 object type
          dc.b      'Q'                 selection keystroke
          dc.w      CHE_OB22-*          pointer to object
          dc.w      7                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 8

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      119                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -8                  object type
          dc.b      'W'                 selection keystroke
          dc.w      CHE_OB23-*          pointer to object
          dc.w      8                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 9

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      134                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'T'                 selection keystroke
          dc.w      CHE_OB24-*          pointer to object
          dc.w      9                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 10

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      147                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -2                  object type
          dc.b      'E'                 selection keystroke
          dc.w      CHE_OB25-*          pointer to object
          dc.w      10                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 11

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      160                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -4                  object type
          dc.b      'K'                 selection keystroke
          dc.w      CHE_OB26-*          pointer to object
          dc.w      11                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 12

          dc.w      18                  hit area   x size
          dc.w      10                             y size
          dc.w      154                            x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      3                   selection keystroke
          dc.w      ESC_OBJ-*           pointer to object
          dc.w      12                  item number
          dc.w      EVENT0-*            pointer to action routine

* Loose menu item n 13

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      4                              x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      5                   selection keystroke
          dc.w      MOVE_SPR-*          pointer to object
          dc.w      13                  item number
          dc.w      EVENT-*             pointer to action routine

* Loose menu item n 14

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      24                             x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      236                 selection keystroke
          dc.w      UNST_SPR-*          pointer to object
          dc.w      14                  item number
          dc.w      STICK-*             pointer to action routine

* Loose menu item n 12

          dc.w      44                  hit area   x size
          dc.w      10                             y size
          dc.w      126                            x origin
          dc.w      177                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      '.'                 selection keystroke
          dc.w      FAKE_ARG-*          pointer to object
          dc.w      15                  item number
          dc.w      CHANGE-*            pointer to action routine

          dc.w      -1                  end flag

CHE_CMDS  dc.w      CHE_CMD1-CHE_CMDS
          dc.w      CHE_CMD2-CHE_CMDS
          dc.w      CHE_CMD3-CHE_CMDS
          dc.w      CHE_CMD4-CHE_CMDS
          dc.w      CHE_CMD5-CHE_CMDS
          dc.w      CHE_CMD6-CHE_CMDS
          dc.w      CHE_CMD7-CHE_CMDS
          dc.w      CHE_CMD8-CHE_CMDS
          dc.w      CHE_CMD9-CHE_CMDS
          dc.w      CHE_CMD10-CHE_CMDS
          dc.w      CHE_CMD11-CHE_CMDS
          dc.w      CHE_CMD12-CHE_CMDS

* Object list:
* ~~~~~~~~~~~

* Object n 1

CHE_OB1   dc.w      4
          dc.b      '  ^S'

CHE_CMD1  dc.w      14
          dc.b      'search-forward'

* Object n 2

CHE_OB2   dc.w      4
          dc.b      '  ^R'

CHE_CMD2  dc.w      14
          dc.b      'search-reverse'

* Object n 3

CHE_OB3   dc.w      4
          dc.b      '  ~S'

CHE_CMD3  dc.w      12
          dc.b      'hunt-forward'

* Object n 4

CHE_OB4   dc.w      4
          dc.b      '  ~R'

CHE_CMD4  dc.w      13
          dc.b      'hunt-backward',0

* Object n 5

CHE_OB5   dc.w      4
          dc.b      '^X S'

CHE_CMD5  dc.w      18
          dc.b      'incremental-search'

* Object n 6

CHE_OB6   dc.w      4
          dc.b      '^X R'

CHE_CMD6  dc.w      26
          dc.b      'reverse-incremental-search'

* Object n 7

CHE_OB7   dc.w      4
          dc.b      'e. R'

CHE_CMD7  dc.w      14
          dc.b      'replace-string'

* Object n 8

CHE_OB8   dc.w      4
          dc.b      'e.^R'

CHE_CMD8  dc.w      20
          dc.b      'query-replace-string'

CHE_CMD9  dc.w      11
          dc.b      'search-word',0

CHE_CMD10 dc.w      8
          dc.b      'tag-word'

CHE_CMD11 dc.w      11
          dc.b      're-tag-word',0

CHE_CMD12 dc.w      18
          dc.b      'back-from-tag-word'

* Object n 13

CHE_OB13  dc.w      6
          dc.b      'Search'

* Object n 15

CHE_OB15  dc.w      14
          dc.b      'Search forward'

* Object n 16

CHE_OB16  dc.w      16
          dc.b      'Search backwards',0

* Object n 17

CHE_OB17  dc.w      15
          dc.b      'Next occurrence',0

* Object n 18

CHE_OB18  dc.w      19
          dc.b      'Previous occurrence',0

* Object n 19

CHE_OB19  dc.w      19
          dc.b      'Incremental forward',0

* Object n 20

CHE_OB20  dc.w      21
          dc.b      'Incremental backwards',0

* Object n 21

CHE_OB21  dc.w      18
          dc.b      'Search and replace'

* Object n 22

CHE_OB22  dc.w      22
          dc.b      'Search & Query/replace'

* Object n 23

CHE_OB23  dc.w      11
          dc.b      'Search word',0

* Object n 24

CHE_OB24  dc.w      8
          dc.b      'Tag word'

* Object n 25

CHE_OB25  dc.w      11
          dc.b      'Re-tag word',0

* Object n 26

CHE_OB26  dc.w      21
          dc.b      'Back from tagged word',0

********************************************************************************
* Sous-menu "Mouvements":
* ~~~~~~~~~~~~~~~~~~~~~~

          dc.w      13                  Numro du loose item "stick/unstick".

          dc.w      MOU_CMDS-MOUVEMENT  Ptr vers table des ptr sur commandes.

MOUVEMENT dc.l      $310                working definition length
          dc.l      $60                 status area length
          dc.b      0                   -1 no mode change, 0/8 force mode 4/8
          dc.b      0                   -1 absolute position, 0 pointer relative
          dc.w      0,0                 absolute initial position

* Main window definition:
* ~~~~~~~~~~~~~~~~~~~~~~

          dc.w      176                 default window x size
          dc.w      175                                y size
          dc.w      134                 initial pointer x position
          dc.w      3                                   y position
          dc.b      0                   MSbit clear to clear window
          dc.b      2                   shadow depth
          dc.w      1                   border width
          dc.w      7                   border colour
          dc.w      0                   paper colour
          dc.w      _hand_spr-*         pointer to pointer sprite

* Menu item attributes

          dc.w      1                   current item border width
          dc.w      4                                border colour

* Menu item unavailable:

          dc.w      0                   background colour
          dc.w      2                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item available:

          dc.w      0                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item selected:

          dc.w      2                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

          dc.w      0                   pointer to help window

* Base of repeated part of window definition

          dc.w      176                 x (min.) size for this layout
          dc.w      175                 y (min.) size for this layout

* Pointers to definition lists:

          dc.w      MOU_IL-*            information sub-windows
          dc.w      MOU_LL-*            loose menu items
          dc.w      0                   application sub-windows

          dc.w      -1                  end flag

* Information sub-window definition list:
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

* Information sub-window n 0

MOU_IL    dc.w      168                 sub-window x size
          dc.w      144                 sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      14                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      MOU_OL0-*           pointer to information object list

* Information sub-window n 1

          dc.w      168                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      161                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      MOU_OL1-*           pointer to information object list

* Information sub-window n 2

          dc.w      110                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      42                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      100                 paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 3

          dc.w      38                  sub-window x size
          dc.w      13                  sub-window y size
          dc.w      66                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      MOU_OL3-*           pointer to information object list

          dc.w      -1                  end flag

* Information sub-window n 0 object list:

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

MOU_OL0   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOU_OB1-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOU_OB3-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOU_OB4-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      54                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOU_OB5-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      67                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOU_OB6-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      80                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOU_OB7-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      93                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOU_OB8-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      106                        y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOU_OB9-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      119                        y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOU_OB10-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      132                        y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOU_OB11-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 1 object list:

MOU_OL1   dc.w      118                 object x size
          dc.w      11                         y size
          dc.w      2                          x origin
          dc.w      1                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      ARG_OBJ-*           pointer to object

          dc.w      -1                  end flag

* Information sub-window n 3 object list:

MOU_OL3   dc.w      30                  object x size
          dc.w      10                         y size
          dc.w      4                          x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOU_OB13-*          pointer to object

          dc.w      -1                  end flag

* Loose menu item list:
* ~~~~~~~~~~~~~~~~~~~~

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

* Loose menu item n 0

MOU_LL    dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      15                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'S'                 selection keystroke
          dc.w      MOU_OB14-*          pointer to object
          dc.w      0                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 1

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      28                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'R'                 selection keystroke
          dc.w      MOU_OB15-*          pointer to object
          dc.w      1                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 2

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      41                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -17                 object type
          dc.b      'M'                 selection keystroke
          dc.w      MOU_OB16-*          pointer to object
          dc.w      2                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 3

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      54                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -2                  object type
          dc.b      'W'                 selection keystroke
          dc.w      MOU_OB17-*          pointer to object
          dc.w      3                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 4

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      67                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'G'                 selection keystroke
          dc.w      MOU_OB18-*          pointer to object
          dc.w      4                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 5

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      80                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -2                  object type
          dc.b      'O'                 selection keystroke
          dc.w      MOU_OB19-*          pointer to object
          dc.w      5                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 6

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      93                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -9                  object type
          dc.b      'E'                 selection keystroke
          dc.w      MOU_OB20-*          pointer to object
          dc.w      6                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 7

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      106                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -7                  object type
          dc.b      'N'                 selection keystroke
          dc.w      MOU_OB21-*          pointer to object
          dc.w      7                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 8

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      119                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -6                  object type
          dc.b      'B'                 selection keystroke
          dc.w      MOU_OB22-*          pointer to object
          dc.w      8                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 9

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      132                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -15                 object type
          dc.b      'F'                 selection keystroke
          dc.w      MOU_OB23-*          pointer to object
          dc.w      9                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 10

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      145                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -6                  object type
          dc.b      'C'                 selection keystroke
          dc.w      MOU_OB24-*          pointer to object
          dc.w      10                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 11

          dc.w      18                  hit area   x size
          dc.w      10                             y size
          dc.w      154                            x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      3                   selection keystroke
          dc.w      ESC_OBJ-*           pointer to object
          dc.w      11                  item number
          dc.w      EVENT0-*            pointer to action routine

* Loose menu item n 12

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      4                              x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      5                   selection keystroke
          dc.w      MOVE_SPR-*          pointer to object
          dc.w      12                  item number
          dc.w      EVENT-*             pointer to action routine

* Loose menu item n 13

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      24                             x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      236                 selection keystroke
          dc.w      UNST_SPR-*          pointer to object
          dc.w      13                  item number
          dc.w      STICK-*             pointer to action routine

* Loose menu item n 14

          dc.w      44                  hit area   x size
          dc.w      10                             y size
          dc.w      126                            x origin
          dc.w      162                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      '.'                 selection keystroke
          dc.w      FAKE_ARG-*          pointer to object
          dc.w      14                  item number
          dc.w      CHANGE-*            pointer to action routine

          dc.w      -1                  end flag

MOU_CMDS  dc.w      MOU_CMD1-MOU_CMDS
          dc.w      MOU_CMD2-MOU_CMDS
          dc.w      MOU_CMD3-MOU_CMDS
          dc.w      MOU_CMD4-MOU_CMDS
          dc.w      MOU_CMD5-MOU_CMDS
          dc.w      MOU_CMD6-MOU_CMDS
          dc.w      MOU_CMD7-MOU_CMDS
          dc.w      MOU_CMD8-MOU_CMDS
          dc.w      MOU_CMD9-MOU_CMDS
          dc.w      MOU_CMD10-MOU_CMDS
          dc.w      MOU_CMD11-MOU_CMDS

* Object list:
* ~~~~~~~~~~~

* Object n 1

MOU_OB1   dc.w      4
          dc.b      'e.sp'

MOU_CMD1  dc.w      8
          dc.b      'set-mark'

* Object n 2

MOU_CMD2  dc.w      11
          dc.b      'remove-mark',0

* Object n 3

MOU_OB3   dc.w      4
          dc.b      'e.^G'

MOU_CMD3  dc.w      9
          dc.b      'goto-mark',0

* Object n 4

MOU_OB4   dc.w      4
          dc.b      '^X^X'

MOU_CMD4  dc.w      23
          dc.b      'exchange-point-and-mark',0

* Object n 5

MOU_OB5   dc.w      4
          dc.b      'e. G'

MOU_CMD5  dc.w      9
          dc.b      'goto-line',0

* Object n 6

MOU_OB6   dc.w      4
          dc.b      'e. <'

MOU_CMD6  dc.w      17
          dc.b      'beginning-of-file',0

* Object n 7

MOU_OB7   dc.w      4
          dc.b      'e. >'

MOU_CMD7  dc.w      11
          dc.b      'end-of-file',0

* Object n 8

MOU_OB8   dc.w      4
          dc.b      'e. N'

MOU_CMD8  dc.w      14
          dc.b      'next-paragraph'

* Object n 9

MOU_OB9   dc.w      4
          dc.b      'e. P'

MOU_CMD9  dc.w      18
          dc.b      'previous-paragraph'

* Object n 10

MOU_OB10  dc.w      4
          dc.b      'e.^F'

MOU_CMD10 dc.w      19
          dc.b      'goto-matching-fence',0

* Object n 11

MOU_OB11  dc.w      4
          dc.b      '^X ='

MOU_CMD11 dc.w      15
          dc.b      'buffer-position',0

* Object n 13

MOU_OB13  dc.w      5
          dc.b      'Moves',0

* Object n 14

MOU_OB14  dc.w      21
          dc.b      'Set a (numbered) mark',0

* Object n 15

MOU_OB15  dc.w      22
          dc.b      'Remove (numbered) mark'

* Object n 16

MOU_OB16  dc.w      20
          dc.b      'Goto a numbered mark'

* Object n 17

MOU_OB17  dc.w      19
          dc.b      'Swap point and mark',0

* Object n 18

MOU_OB18  dc.w      20
          dc.b      'Goto a numbered line'

* Object n 19

MOU_OB19  dc.w      22
          dc.b      'Move to start of buff.'

* Object n 20

MOU_OB20  dc.w      21
          dc.b      'Move to end of buffer',0

* Object n 21

MOU_OB21  dc.w      21
          dc.b      'Goto end of paragraph',0

* Object n 22

MOU_OB22  dc.w      22
          dc.b      'Goto begining paragra.'

* Object n 23

MOU_OB23  dc.w      19
          dc.b      'Goto matching fence',0

* Object n 24

MOU_OB24  dc.w      20
          dc.b      'Show cursor position'

********************************************************************************
* Sous-menu "Tampons/crans":
* ~~~~~~~~~~~~~~~~~~~~~~~~~~

          dc.w      17                  Numro du loose item "stick/unstick".

          dc.w      TAM_CMDS-TAMPONS    Ptr vers table des ptr sur commandes.

TAMPONS   dc.l      $420                working definition length
          dc.l      $70                 status area length
          dc.b      0                   -1 no mode change, 0/8 force mode 4/8
          dc.b      0                   -1 absolute position, 0 pointer relative
          dc.w      0,0                 absolute initial position

* Main window definition:
* ~~~~~~~~~~~~~~~~~~~~~~

          dc.w      176                 default window x size
          dc.w      245                                y size
          dc.w      134                 initial pointer x position
          dc.w      3                                   y position
          dc.b      0                   MSbit clear to clear window
          dc.b      2                   shadow depth
          dc.w      1                   border width
          dc.w      7                   border colour
          dc.w      0                   paper colour
          dc.w      _hand_spr-*         pointer to pointer sprite

* Menu item attributes:

          dc.w      1                   current item border width
          dc.w      4                                border colour

* Menu item unavailable:

          dc.w      0                   background colour
          dc.w      2                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item available:

          dc.w      0                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item selected:

          dc.w      2                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

          dc.w      0                   pointer to help window

* Base of repeated part of window definition

          dc.w      176                 x (min.) size for this layout
          dc.w      245                 y (min.) size for this layout

* Pointers to definition lists:

          dc.w      TAM_IL-*            information sub-windows
          dc.w      TAM_LL-*            loose menu items
          dc.w      0                   application sub-windows

          dc.w      -1                  end flag

* Information sub-window definition list:
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

* Information sub-window n 0

TAM_IL    dc.w      168                 sub-window x size
          dc.w      144                 sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      14                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      TAM_OL0-*           pointer to information object list

* Information sub-window n 1

          dc.w      168                 sub-window x size
          dc.w      53                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      175                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      TAM_OL1-*           pointer to information object list

* Information sub-window n 2

          dc.w      168                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      231                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      TAM_OL2-*           pointer to information object list

* Information sub-window n 3

          dc.w      110                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      42                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      100                 paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 4

          dc.w      50                  sub-window x size
          dc.w      12                  sub-window y size
          dc.w      60                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      TAM_OL4-*           pointer to information object list

* Information sub-window n 5

          dc.w      176                 sub-window x size
          dc.w      2                   sub-window y size
          dc.w      0                   sub-window x origin
          dc.w      159                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      112                 paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 6

          dc.w      176                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      0                   sub-window x origin
          dc.w      161                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      96                  paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 7

          dc.w      50                  sub-window x size
          dc.w      12                  sub-window y size
          dc.w      60                  sub-window x origin
          dc.w      161                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      TAM_OL7-*           pointer to information object list

          dc.w      -1                  end flag

* Information sub-window n 0 object list:

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

TAM_OL0   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      TAM_OB1-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      TAM_OB2-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      TAM_OB3-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      TAM_OB4-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      54                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      TAM_OB5-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      67                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      TAM_OB6-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      80                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      TAM_OB7-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      93                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      106                        y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      119                        y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      132                        y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      TAM_OB11-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 1 object list:

TAM_OL1   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      TAM_OB12-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      TAM_OB13-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      TAM_OB14-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      TAM_OB15-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 2 object list:

TAM_OL2   dc.w      120                 object x size
          dc.w      10                         y size
          dc.w      2                          x origin
          dc.w      1                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      ARG_OBJ-*           pointer to object

          dc.w      -1                  end flag

* Information sub-window n 4 object list:

TAM_OL4   dc.w      44                  object x size
          dc.w      10                         y size
          dc.w      4                          x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      TAM_OB17-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 7 object list:

TAM_OL7   dc.w      42                  object x size
          dc.w      10                         y size
          dc.w      4                          x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      TAM_OB18-*          pointer to object

          dc.w      -1                  end flag

* Loose menu item list:
* ~~~~~~~~~~~~~~~~~~~~

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

* Loose menu item n 0

TAM_LL    dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      15                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'R'                 selection keystroke
          dc.w      TAM_OB19-*          pointer to object
          dc.w      0                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 1

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      28                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -9                  object type
          dc.b      'B'                 selection keystroke
          dc.w      TAM_OB20-*          pointer to object
          dc.w      1                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 2

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      41                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'U'                 selection keystroke
          dc.w      TAM_OB21-*          pointer to object
          dc.w      2                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 3

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      54                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'D'                 selection keystroke
          dc.w      TAM_OB22-*          pointer to object
          dc.w      3                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 4

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      67                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -5                  object type
          dc.b      'N'                 selection keystroke
          dc.w      TAM_OB23-*          pointer to object
          dc.w      4                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 5

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      80                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -8                  object type
          dc.b      'W'                 selection keystroke
          dc.w      TAM_OB24-*          pointer to object
          dc.w      5                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 6

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      93                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'E'                 selection keystroke
          dc.w      TAM_OB25-*          pointer to object
          dc.w      6                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 7

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      106                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'S'                 selection keystroke
          dc.w      TAM_OB26-*          pointer to object
          dc.w      7                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 8

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      119                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -4                  object type
          dc.b      'A'                 selection keystroke
          dc.w      TAM_OB27-*          pointer to object
          dc.w      8                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 9

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      132                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'K'                 selection keystroke
          dc.w      TAM_OB28-*          pointer to object
          dc.w      9                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 10

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      145                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -5                  object type
          dc.b      'T'                 selection keystroke
          dc.w      TAM_OB29-*          pointer to object
          dc.w      10                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 11

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      177                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'F'                 selection keystroke
          dc.w      TAM_OB30-*          pointer to object
          dc.w      11                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 12

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      190                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'C'                 selection keystroke
          dc.w      TAM_OB31-*          pointer to object
          dc.w      12                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 13

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      203                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -3                  object type
          dc.b      'L'                 selection keystroke
          dc.w      TAM_OB32-*          pointer to object
          dc.w      13                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 14

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      216                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -2                  object type
          dc.b      'I'                 selection keystroke
          dc.w      TAM_OB33-*          pointer to object
          dc.w      14                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 15

          dc.w      18                  hit area   x size
          dc.w      10                             y size
          dc.w      154                            x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      3                   selection keystroke
          dc.w      ESC_OBJ-*           pointer to object
          dc.w      15                  item number
          dc.w      EVENT0-*            pointer to action routine

* Loose menu item n 16

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      4                              x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      5                   selection keystroke
          dc.w      MOVE_SPR-*          pointer to object
          dc.w      16                  item number
          dc.w      EVENT-*             pointer to action routine

* Loose menu item n 17

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      24                             x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      236                 selection keystroke
          dc.w      UNST_SPR-*          pointer to object
          dc.w      17                  item number
          dc.w      STICK-*             pointer to action routine

* Loose menu item n 18

          dc.w      44                  hit area   x size
          dc.w      10                             y size
          dc.w      126                            x origin
          dc.w      233                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      '.'                 selection keystroke
          dc.w      FAKE_ARG-*          pointer to object
          dc.w      18                  item number
          dc.w      CHANGE-*            pointer to action routine

          dc.w      -1                  end flag

TAM_CMDS  dc.w      TAM_CMD1-TAM_CMDS
          dc.w      TAM_CMD2-TAM_CMDS
          dc.w      TAM_CMD3-TAM_CMDS
          dc.w      TAM_CMD4-TAM_CMDS
          dc.w      TAM_CMD5-TAM_CMDS
          dc.w      TAM_CMD6-TAM_CMDS
          dc.w      TAM_CMD7-TAM_CMDS
          dc.w      TAM_CMD8-TAM_CMDS
          dc.w      TAM_CMD9-TAM_CMDS
          dc.w      TAM_CMD10-TAM_CMDS
          dc.w      TAM_CMD11-TAM_CMDS
          dc.w      TAM_CMD12-TAM_CMDS
          dc.w      TAM_CMD13-TAM_CMDS
          dc.w      TAM_CMD14-TAM_CMDS
          dc.w      TAM_CMD15-TAM_CMDS

* Object list:
* ~~~~~~~~~~~

* Object n 1

TAM_OB1   dc.w      4
          dc.b      'e.^N'

TAM_CMD1  dc.w      11
          dc.b      'name-buffer',0

* Object n 2

TAM_OB2   dc.w      4
          dc.b      '^X^B'

TAM_CMD2  dc.w      12
          dc.b      'list-buffers'

* Object n 3

TAM_OB3   dc.w      4
          dc.b      'e. ~'

TAM_CMD3  dc.w      13
          dc.b      'unmark-buffer',0

* Object n 4

TAM_OB4   dc.w      4
          dc.b      '^X K'

TAM_CMD4  dc.w      13
          dc.b      'delete-buffer',0

* Object n 5

TAM_OB5   dc.w      4
          dc.b      '^X X'

TAM_CMD5  dc.w      11
          dc.b      'next-buffer',0

* Object n 6

TAM_OB6   dc.w      4
          dc.b      '^X B'

TAM_CMD6  dc.w      13
          dc.b      'select-buffer',0

* Object n 7

TAM_OB7   dc.w      4
          dc.b      'e.^Y'

TAM_CMD7  dc.w      16
          dc.b      'delete-kill-ring'

TAM_CMD8  dc.w      20
          dc.b      'scrap-to-kill-buffer'

TAM_CMD9  dc.w      11
          dc.b      'clear-scrap',0

TAM_CMD10 dc.w      20
          dc.b      'kill-buffer-to-scrap'

* Object n 11

TAM_OB11  dc.w      4
          dc.b      'e. E'

TAM_CMD11 dc.w      18
          dc.b      'set-encryption-key'

* Object n 12

TAM_OB12  dc.w      4
          dc.b      '  ~F'

TAM_CMD12 dc.w      11
          dc.b      'find-screen',0

* Object n 13

TAM_OB13  dc.w      4
          dc.b      '  ~C'

TAM_CMD13 dc.w      13
          dc.b      'cycle-screens',0

* Object n 14

TAM_OB14  dc.w      4
          dc.b      '  ~D'

TAM_CMD14 dc.w      13
          dc.b      'delete-screen',0

* Object n 15

TAM_OB15  dc.w      4
          dc.b      '  ~B'

TAM_CMD15 dc.w      12
          dc.b      'list-screens'

* Object n 17

TAM_OB17  dc.w      7
          dc.b      'Buffers',0

* Object n 18

TAM_OB18  dc.w      7
          dc.b      'Screens',0

* Object n 19

TAM_OB19  dc.w      21
          dc.b      'Rename current buffer',0

* Object n 20

TAM_OB20  dc.w      19
          dc.b      'Display buffer list',0

* Object n 21

TAM_OB21  dc.w      21
          dc.b      'Unmark current buffer',0

* Object n 22

TAM_OB22  dc.w      15
          dc.b      'Delete a buffer',0

* Object n 23

TAM_OB23  dc.w      15
          dc.b      'Use next buffer',0

* Object n 24

TAM_OB24  dc.w      22
          dc.b      'Switch wind. to buffer'

* Object n 25

TAM_OB25  dc.w      17
          dc.b      'Erase kill buffer',0

* Object n 26

TAM_OB26  dc.w      20
          dc.b      'Scrap to kill buffer'

* Object n 27

TAM_OB27  dc.w      11
          dc.b      'Clear scrap',0

* Object n 28

TAM_OB28  dc.w      20
          dc.b      'Kill buffer to scrap'

* Object n 29

TAM_OB29  dc.w      20
          dc.b      'Reset encryption key'

* Object n 30

TAM_OB30  dc.w      18
          dc.b      'Find/create screen'

* Object n 31

TAM_OB31  dc.w      13
          dc.b      'Cycle screens',0

* Object n 32

TAM_OB32  dc.w      15
          dc.b      'Delete a screen',0

* Object n 33

TAM_OB33  dc.w      16
          dc.b      'List all screens'

********************************************************************************
* Sous-menu "Fentres":
* ~~~~~~~~~~~~~~~~~~~~

          dc.w      12                  Numro du loose item "stick/unstick".

          dc.w      FEN_CMDS-FENETRES   Ptr vers table des ptr sur commandes.

FENETRES  dc.l      $2F0                working definition length
          dc.l      $60                 status area length
          dc.b      0                   -1 no mode change, 0/8 force mode 4/8
          dc.b      0                   -1 absolute position, 0 pointer relative
          dc.w      0,0                 absolute initial position

* Main window definition:
* ~~~~~~~~~~~~~~~~~~~~~~

          dc.w      176                 default window x size
          dc.w      162                                y size
          dc.w      134                 initial pointer x position
          dc.w      3                                   y position
          dc.b      0                   MSbit clear to clear window
          dc.b      2                   shadow depth
          dc.w      1                   border width
          dc.w      7                   border colour
          dc.w      0                   paper colour
          dc.w      _hand_spr-*         pointer to pointer sprite

* Menu item attributes:

          dc.w      1                   current item border width
          dc.w      4                                border colour

* Menu item unavailable:

          dc.w      0                   background colour
          dc.w      2                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item available:

          dc.w      0                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item selected:

          dc.w      2                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

          dc.w      0                   pointer to help window

* Base of repeated part of window definition

          dc.w      176                 x (min.) size for this layout
          dc.w      162                 y (min.) size for this layout

* Pointers to definition lists:

          dc.w      FEN_IL-*            information sub-windows
          dc.w      FEN_LL-*            loose menu items
          dc.w      0                   application sub-windows

          dc.w      -1                  end flag

* Information sub-window definition list:
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

* Information sub-window n 0

FEN_IL    dc.w      168                 sub-window x size
          dc.w      131                 sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      14                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      FEN_OL0-*           pointer to information object list

* Information sub-window n 1

          dc.w      110                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      42                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      100                 paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 2

          dc.w      50                  sub-window x size
          dc.w      12                  sub-window y size
          dc.w      62                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      FEN_OL2-*           pointer to information object list

* Information sub-window n 3

          dc.w      168                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      148                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      FEN_OL3-*           pointer to information object list

          dc.w      -1                  end flag

* Information sub-window n 0 object list:

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

FEN_OL0   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FEN_OB1-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FEN_OB2-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FEN_OB3-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FEN_OB4-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      54                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FEN_OB5-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      67                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FEN_OB6-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      80                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FEN_OB7-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      93                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FEN_OB8-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      106                        y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FEN_OB9-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      119                        y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FEN_OB10-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 2 object list:

FEN_OL2   dc.w      44                  object x size
          dc.w      10                         y size
          dc.w      4                          x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      FEN_OB11-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 3 object list:

FEN_OL3   dc.w      120                 object x size
          dc.w      10                         y size
          dc.w      2                          x origin
          dc.w      1                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      ARG_OBJ-*           pointer to object

          dc.w      -1                  end flag

* Loose menu item list:
* ~~~~~~~~~~~~~~~~~~~~

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

* Loose menu item n 0

FEN_LL    dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      15                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'S'                 selection keystroke
          dc.w      FEN_OB13-*          pointer to object
          dc.w      0                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 1

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      28                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'D'                 selection keystroke
          dc.w      FEN_OB14-*          pointer to object
          dc.w      1                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 2

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      41                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -8                  object type
          dc.b      'O'                 selection keystroke
          dc.w      FEN_OB15-*          pointer to object
          dc.w      2                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 3

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      54                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -9                  object type
          dc.b      'N'                 selection keystroke
          dc.w      FEN_OB16-*          pointer to object
          dc.w      3                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 4

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      67                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -9                  object type
          dc.b      'P'                 selection keystroke
          dc.w      FEN_OB17-*          pointer to object
          dc.w      4                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 5

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      80                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'E'                 selection keystroke
          dc.w      FEN_OB18-*          pointer to object
          dc.w      5                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 6

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      93                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -2                  object type
          dc.b      'H'                 selection keystroke
          dc.w      FEN_OB19-*          pointer to object
          dc.w      6                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 7

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      106                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'R'                 selection keystroke
          dc.w      FEN_OB20-*          pointer to object
          dc.w      7                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 8

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      119                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -20                 object type
          dc.b      'U'                 selection keystroke
          dc.w      FEN_OB21-*          pointer to object
          dc.w      8                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 9

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      132                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -2                  object type
          dc.b      'C'                 selection keystroke
          dc.w      FEN_OB22-*          pointer to object
          dc.w      9                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 10

          dc.w      18                  hit area   x size
          dc.w      10                             y size
          dc.w      154                            x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      3                   selection keystroke
          dc.w      ESC_OBJ-*           pointer to object
          dc.w      10                  item number
          dc.w      EVENT0-*            pointer to action routine

* Loose menu item n 11

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      4                              x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      5                   selection keystroke
          dc.w      MOVE_SPR-*          pointer to object
          dc.w      11                  item number
          dc.w      EVENT-*             pointer to action routine

* Loose menu item n 12

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      24                             x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      5                   selection keystroke
          dc.w      UNST_SPR-*          pointer to object
          dc.w      12                  item number
          dc.w      STICK-*             pointer to action routine

* Loose menu item n 13

          dc.w      44                  hit area   x size
          dc.w      10                             y size
          dc.w      126                            x origin
          dc.w      149                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      '.'                 selection keystroke
          dc.w      FAKE_ARG-*          pointer to object
          dc.w      13                  item number
          dc.w      CHANGE-*            pointer to action routine

          dc.w      -1                  end flag

FEN_CMDS  dc.w      FEN_CMD1-FEN_CMDS
          dc.w      FEN_CMD2-FEN_CMDS
          dc.w      FEN_CMD3-FEN_CMDS
          dc.w      FEN_CMD4-FEN_CMDS
          dc.w      FEN_CMD5-FEN_CMDS
          dc.w      FEN_CMD6-FEN_CMDS
          dc.w      FEN_CMD7-FEN_CMDS
          dc.w      FEN_CMD8-FEN_CMDS
          dc.w      FEN_CMD9-FEN_CMDS
          dc.w      FEN_CMD10-FEN_CMDS

* Object list:
* ~~~~~~~~~~~

* Object n 1

FEN_OB1   dc.w      4
          dc.b      '^X 2'

FEN_CMD1  dc.w      20
          dc.b      'split-current-window'

* Object n 2

FEN_OB2   dc.w      4
          dc.b      '^X 0'

FEN_CMD2  dc.w      13
          dc.b      'delete-window',0

* Object n 3

FEN_OB3   dc.w      4
          dc.b      '^X 1'

FEN_CMD3  dc.w      20
          dc.b      'delete-other-windows'

* Object n 4

FEN_OB4   dc.w      4
          dc.b      '^X O'

FEN_CMD4  dc.w      11
          dc.b      'next-window',0

* Object n 5

FEN_OB5   dc.w      4
          dc.b      '^X P'

FEN_CMD5  dc.w      15
          dc.b      'previous-window',0

* Object n 6

FEN_OB6   dc.w      4
          dc.b      '^X Z'

FEN_CMD6  dc.w      11
          dc.b      'grow-window',0

* Object n 7

FEN_OB7   dc.w      4
          dc.b      '^X^Z'

FEN_CMD7  dc.w      13
          dc.b      'shrink-window',0

* Object n 8

FEN_OB8   dc.w      4
          dc.b      '^X W'

FEN_CMD8  dc.w      13
          dc.b      'resize-window',0

* Object n 9

FEN_OB9   dc.w      4
          dc.b      'e.^Z'

FEN_CMD9  dc.w      14
          dc.b      'scroll-next-up'

* Object n 10

FEN_OB10  dc.w      4
          dc.b      'e.^V'

FEN_CMD10 dc.w      16
          dc.b      'scroll-next-down'

* Object n 11

FEN_OB11  dc.w      7
          dc.b      'Windows',0

* Object n 13

FEN_OB13  dc.w      20
          dc.b      'Split current window'

* Object n 14

FEN_OB14  dc.w      21
          dc.b      'Delete current window',0

* Object n 15

FEN_OB15  dc.w      20
          dc.b      'Delete other windows'

* Object n 16

FEN_OB16  dc.w      19
          dc.b      'Move to next window',0

* Object n 17

FEN_OB17  dc.w      22
          dc.b      'Move to previous wind.'

* Object n 18

FEN_OB18  dc.w      22
          dc.b      'Enlarge current window'

* Object n 19

FEN_OB19  dc.w      21
          dc.b      'Shrink current window',0

* Object n 20

FEN_OB20  dc.w      21
          dc.b      'Resize current window',0

* Object n 21

FEN_OB21  dc.w      21
          dc.b      'Scroll next window up',0

* Object n 22

FEN_OB22  dc.w      22
          dc.b      'Scroll next wind. down'

********************************************************************************
* Sous-menu "Modes/variables":
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~

MODEITEM  equ       3                   Premier item associ aux modes.
FIRSTMODE equ       7                   Premier loose item dcrivant un mode.
LASTMODE  equ       18                  Dernier loose item dcrivant un mode.

          dc.w      21                  Numro du loose item "stick/unstick".

          dc.w      MOD_CMDS-MODES      Ptr vers table des ptr sur commandes.

MODES     dc.l      $3C0                working definition length
          dc.l      $70                 status area length
          dc.b      0                   -1 no mode change, 0/8 force mode 4/8
          dc.b      0                   -1 absolute position, 0 pointer relative
          dc.w      0,0                 absolute initial position

* Main window definition:
* ~~~~~~~~~~~~~~~~~~~~~~

          dc.w      176                 default window x size
          dc.w      167                                y size
          dc.w      134                 initial pointer x position
          dc.w      3                                   y position
          dc.b      0                   MSbit clear to clear window
          dc.b      2                   shadow depth
          dc.w      1                   border width
          dc.w      7                   border colour
          dc.w      0                   paper colour
          dc.w      _hand_spr-*         pointer to pointer sprite

* Menu item attributes:

          dc.w      1                   current item border width
          dc.w      4                                border colour

* Menu item unavailable:

          dc.w      0                   background colour
          dc.w      2                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item available:

          dc.w      0                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item selected:

          dc.w      2                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

          dc.w      0                   pointer to help window

* Base of repeated part of window definition

          dc.w      176                 x (min.) size for this layout
          dc.w      167                 y (min.) size for this layout

* Pointers to definition lists:

          dc.w      MOD_IL-*            information sub-windows
          dc.w      MOD_LL-*            loose menu items
          dc.w      0                   application sub-windows

          dc.w      -1                  end flag

* Information sub-window definition list:
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

* Information sub-window n 0

MOD_IL    dc.w      168                 sub-window x size
          dc.w      40                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      14                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      MOD_OL0-*           pointer to information object list

* Information sub-window n 1

          dc.w      168                 sub-window x size
          dc.w      53                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      71                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      MOD_OL1-*           pointer to information object list

* Information sub-window n 2

          dc.w      168                 sub-window x size
          dc.w      40                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      125                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 3

          dc.w      110                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      42                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      100                 paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 4

          dc.w      62                  sub-window x size
          dc.w      12                  sub-window y size
          dc.w      54                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      MOD_OL4-*           pointer to information object list

* Information sub-window n 5

          dc.w      176                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      0                   sub-window x origin
          dc.w      57                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      96                  paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 6

          dc.w      62                  sub-window x size
          dc.w      12                  sub-window y size
          dc.w      54                  sub-window x origin
          dc.w      58                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      MOD_OL6-*           pointer to information object list

* Information sub-window n 7

          dc.w      176                 sub-window x size
          dc.w      2                   sub-window y size
          dc.w      0                   sub-window x origin
          dc.w      55                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      112                 paper colour
          dc.w      0                   pointer to information object list

          dc.w      -1                  end flag

* Information sub-window n 0 object list:

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

MOD_OL0   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOD_OB1-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOD_OB2-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 1 object list:

MOD_OL1   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOD_OB4-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOD_OB5-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOD_OB6-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOD_OB7-*           pointer to object

          dc.w      -1                  end flag

* Information sub-window n 4 object list:

MOD_OL4   dc.w      56                  object x size
          dc.w      10                         y size
          dc.w      4                          x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOD_OB8-*           pointer to object

          dc.w      -1                  end flag

* Information sub-window n 6 object list:

MOD_OL6   dc.w      38                  object x size
          dc.w      10                         y size
          dc.w      16                         x origin
          dc.w      1                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      MOD_OB9-*           pointer to object

          dc.w      -1                  end flag

* Loose menu item list:
* ~~~~~~~~~~~~~~~~~~~~

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

* Loose menu item n 0

MOD_LL    dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      15                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -11                 object type
          dc.b      'V'                 selection keystroke
          dc.w      MOD_OB10-*          pointer to object
          dc.w      0                   item number
          dc.w      SEND_VAR-*          pointer to action routine

* Loose menu item n 1

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      28                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -3                  object type
          dc.b      'T'                 selection keystroke
          dc.w      MOD_OB11-*          pointer to object
          dc.w      1                   item number
          dc.w      SENDFVAR-*          pointer to action routine

* Loose menu item n 2

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      41                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'L'                 selection keystroke
          dc.w      MOD_OB12-*          pointer to object
          dc.w      2                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 3

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      72                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'A'                 selection keystroke
          dc.w      MOD_OB13-*          pointer to object
          dc.w      3                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 4

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      85                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'D'                 selection keystroke
          dc.w      MOD_OB14-*          pointer to object
          dc.w      4                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 5

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      98                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -14                 object type
          dc.b      'M'                 selection keystroke
          dc.w      MOD_OB15-*          pointer to object
          dc.w      5                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 6

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      111                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -2                  object type
          dc.b      'E'                 selection keystroke
          dc.w      MOD_OB16-*          pointer to object
          dc.w      6                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 7

          dc.w      38                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      126                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'W'                 selection keystroke
          dc.w      MOD_OB17-*          pointer to object
          dc.w      7                   item number
          dc.w      SELECTONE-*         pointer to action routine

* Loose menu item n 8

          dc.w      38                  hit area   x size
          dc.w      12                             y size
          dc.w      48                             x origin
          dc.w      126                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -2                  object type
          dc.b      'I'                 selection keystroke
          dc.w      MOD_OB18-*          pointer to object
          dc.w      8                   item number
          dc.w      SELECTONE-*         pointer to action routine

* Loose menu item n 9

          dc.w      38                  hit area   x size
          dc.w      12                             y size
          dc.w      90                             x origin
          dc.w      126                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'C'                 selection keystroke
          dc.w      MOD_OB19-*          pointer to object
          dc.w      9                   item number
          dc.w      SELECTONE-*         pointer to action routine

* Loose menu item n 10

          dc.w      38                  hit area   x size
          dc.w      12                             y size
          dc.w      132                            x origin
          dc.w      126                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -2                  object type
          dc.b      'X'                 selection keystroke
          dc.w      MOD_OB20-*          pointer to object
          dc.w      10                  item number
          dc.w      SELECTONE-*         pointer to action routine

* Loose menu item n 11

          dc.w      38                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      139                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'O'                 selection keystroke
          dc.w      MOD_OB21-*          pointer to object
          dc.w      11                  item number
          dc.w      SELECTONE-*         pointer to action routine

* Loose menu item n 12

          dc.w      38                  hit area   x size
          dc.w      12                             y size
          dc.w      48                             x origin
          dc.w      139                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -3                  object type
          dc.b      'Y'                 selection keystroke
          dc.w      MOD_OB22-*          pointer to object
          dc.w      12                  item number
          dc.w      SELECTONE-*         pointer to action routine

* Loose menu item n 13

          dc.w      38                  hit area   x size
          dc.w      12                             y size
          dc.w      90                             x origin
          dc.w      139                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -3                  object type
          dc.b      'G'                 selection keystroke
          dc.w      MOD_OB23-*          pointer to object
          dc.w      13                  item number
          dc.w      SELECTONE-*         pointer to action routine

* Loose menu item n 14

          dc.w      38                  hit area   x size
          dc.w      12                             y size
          dc.w      132                            x origin
          dc.w      139                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -2                  object type
          dc.b      'S'                 selection keystroke
          dc.w      MOD_OB24-*          pointer to object
          dc.w      14                  item number
          dc.w      SELECTONE-*         pointer to action routine

* Loose menu item n 15

          dc.w      38                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      152                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'R'                 selection keystroke
          dc.w      MOD_OB25-*          pointer to object
          dc.w      15                  item number
          dc.w      SELECTONE-*         pointer to action routine

* Loose menu item n 16

          dc.w      38                  hit area   x size
          dc.w      12                             y size
          dc.w      48                             x origin
          dc.w      152                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -2                  object type
          dc.b      'B'                 selection keystroke
          dc.w      MOD_OB26-*          pointer to object
          dc.w      16                  item number
          dc.w      SELECTONE-*         pointer to action routine

* Loose menu item n 17

          dc.w      38                  hit area   x size
          dc.w      12                             y size
          dc.w      90                             x origin
          dc.w      152                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -2                  object type
          dc.b      'P'                 selection keystroke
          dc.w      MOD_OB27-*          pointer to object
          dc.w      17                  item number
          dc.w      SELECTONE-*         pointer to action routine

* Loose menu item n 18

          dc.w      38                  hit area   x size
          dc.w      12                             y size
          dc.w      132                            x origin
          dc.w      152                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'H'                 selection keystroke
          dc.w      MOD_OB28-*          pointer to object
          dc.w      18                  item number
          dc.w      SELECTONE-*         pointer to action routine

* Loose menu item n 19

          dc.w      18                  hit area   x size
          dc.w      10                             y size
          dc.w      154                            x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      3                   selection keystroke
          dc.w      ESC_OBJ-*           pointer to object
          dc.w      19                  item number
          dc.w      EVENT0-*            pointer to action routine

* Loose menu item n 20

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      4                              x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      5                   selection keystroke
          dc.w      MOVE_SPR-*          pointer to object
          dc.w      20                  item number
          dc.w      EVENT-*             pointer to action routine

* Loose menu item n 21

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      24                             x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      236                 selection keystroke
          dc.w      UNST_SPR-*          pointer to object
          dc.w      21                  item number
          dc.w      STICK-*             pointer to action routine

          dc.w      -1                  end flag

MOD_CMDS  dc.w      MOD_CMD1-MOD_CMDS
          dc.w      MOD_CMD2-MOD_CMDS
          dc.w      MOD_CMD3-MOD_CMDS
          dc.w      MOD_CMD4-MOD_CMDS
          dc.w      MOD_CMD5-MOD_CMDS
          dc.w      MOD_CMD6-MOD_CMDS
          dc.w      MOD_CMD7-MOD_CMDS

* Object list:
* ~~~~~~~~~~~

* Object n 1

MOD_OB1   dc.w      4
          dc.b      '^X G'

MOD_CMD1  dc.w      7
          dc.b      'display',0

* Object n 2

MOD_OB2   dc.w      4
          dc.b      '^X A'

MOD_CMD2  dc.w      3
          dc.b      'set',0

MOD_CMD3  dc.w      18
          dc.b      'describe-variables'

* Object n 4

MOD_OB4   dc.w      4
          dc.b      '^X M'

MOD_CMD4  dc.w      8
          dc.b      'add-mode'

* Object n 5

MOD_OB5   dc.w      4
          dc.b      '^X^M'

MOD_CMD5  dc.w      11
          dc.b      'delete-mode',0

* Object n 6

MOD_OB6   dc.w      4
          dc.b      'e. M'

MOD_CMD6  dc.w      15
          dc.b      'add-global-mode',0

* Object n 7

MOD_OB7   dc.w      4
          dc.b      'e.^M'

MOD_CMD7  dc.w      18
          dc.b      'delete-global-mode'

* Object n 8

MOD_OB8   dc.w      9
          dc.b      'Variables',0

* Object n 9

MOD_OB9   dc.w      5
          dc.b      'Modes',0

* Object n 10

MOD_OB10  dc.w      18
          dc.b      'Display a variable'

* Object n 11

MOD_OB11  dc.w      20
          dc.b      'Set a variable value'

* Object n 12

MOD_OB12  dc.w      18
          dc.b      'List all variables'

* Object n 13

MOD_OB13  dc.w      10
          dc.b      'Add a mode'

* Object n 14

MOD_OB14  dc.w      13
          dc.b      'Delete a mode',0

* Object n 15

MOD_OB15  dc.w      17
          dc.b      'Add a global mode',0

* Object n 16

MOD_OB16  dc.w      20
          dc.b      'Delete a global mode'

* Object n 17

MOD_OB17  dc.w      4
          dc.b      'WRAP'

* Object n 18

MOD_OB18  dc.w      4
          dc.b      'VIEW'

* Object n 19

MOD_OB19  dc.w      5
          dc.b      'CMODE',0

* Object n 20

MOD_OB20  dc.w      5
          dc.b      'EXACT',0

* Object n 21

MOD_OB21  dc.w      4
          dc.b      'OVER'

* Object n 22

MOD_OB22  dc.w      5
          dc.b      'CRYPT',0

* Object n 23

MOD_OB23  dc.w      5
          dc.b      'MAGIC',0

* Object n 24

MOD_OB24  dc.w      5
          dc.b      'ASAVE',0

* Object n 25

MOD_OB25  dc.w      3
          dc.b      'REP',0

* Object n 26

MOD_OB26  dc.w      6
          dc.b      'ABBREV'

* Object n 27

MOD_OB27  dc.w      5
          dc.b      'SPELL',0

* Object n 28

MOD_OB28  dc.w      6
          dc.b      'HILITE'

********************************************************************************
* Sous-menus "Choix des variables":
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

TRUEITEM  equ       119                 Numro de l'item "TRUE".
FALSEITEM equ       120                 Numro de l'item "FALSE".

          dc.w      -1                  Numro du loose item "stick/unstick".

          dc.w      0                   Pas de pointeur vers table des codes.

VARIABLES dc.l      $B90                working definition length
          dc.l      $D0                 status area length
          dc.b      0                   -1 absolute position, 0 pointer relative
          dc.b      0                   -1 no mode change, 0/8 force mode 4/8
          dc.w      0,0                 absolute initial position (set_org = -1)

* Main window definition:
* ~~~~~~~~~~~~~~~~~~~~~~

          dc.w      472                 default window x size
          dc.w      251                                y size
          dc.w      354                 initial pointer x position
          dc.w      3                                   y position
          dc.b      0                   MSbit clear to clear window
          dc.b      1                   shadow depth
          dc.w      1                   border width
          dc.w      7                   border colour
          dc.w      0                   paper colour
          dc.w      _hand_spr-*         pointer to pointer sprite

* Menu item attributes:

          dc.w      1                   current item border width
          dc.w      4                                border colour

* Menu item unavailable:

          dc.w      0                   background colour
          dc.w      2                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item available:

          dc.w      0                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item selected:

          dc.w      2                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

          dc.w      0                   pointer to help window

* Base of repeated part of window definition:

          dc.w      472                 x (min.) size for this layout
          dc.w      251                 y (min.) size for this layout

* Pointers to definition lists:

          dc.w      VAR_IL-*            information sub-windows
          dc.w      VAR_LL-*            loose menu items
          dc.w      0                   application sub-windows

          dc.w      -1                  end flag

* Information sub-window definition list:
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

* Information sub-window n 0

VAR_IL    dc.w      464                 sub-window x size
          dc.w      235                 sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      14                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      VAR_OL0-*           pointer to information object list

* Information sub-window n 1

          dc.w      412                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      30                  sub-window x origin
          dc.w      1                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      100                 paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 2

          dc.w      64                  sub-window x size
          dc.w      12                  sub-window y size
          dc.w      200                 sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      VAR_OL2-*           pointer to information object list

          dc.w      -1                  end flag

* Information sub-window n 0 object list:

* Object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

VAR_OL0   dc.w      316                 object x size
          dc.w      12                         y size
          dc.w      12                         x origin
          dc.w      223                        y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      VAR_OB1-*           pointer to object

          dc.w      16                  object x size
          dc.w      12                         y size
          dc.w      390                        x origin
          dc.w      223                        y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      VAR_OB2-*           pointer to object

          dc.w      -1                  end flag

* Information sub-window n 2 object list:

* Object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

VAR_OL2   dc.w      60                  object x size
          dc.w      10                         y size
          dc.w      4                          x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      VAR_OB3-*           pointer to object

          dc.w      -1                  end flag

* Loose menu item list:
* ~~~~~~~~~~~~~~~~~~~~

* Object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

* Loose menu item n 0

VAR_LL    dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      15                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB4-*           pointer to object
          dc.w      0                   item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 1

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      15                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB5-*           pointer to object
          dc.w      1                   item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 2

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      15                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB6-*           pointer to object
          dc.w      2                   item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 3

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      15                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB7-*           pointer to object
          dc.w      3                   item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 4

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      15                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB8-*           pointer to object
          dc.w      4                   item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 5

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      15                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB9-*           pointer to object
          dc.w      5                   item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 6

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      15                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB10-*          pointer to object
          dc.w      6                   item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 7

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      28                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB11-*          pointer to object
          dc.w      7                   item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 8

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      28                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB12-*          pointer to object
          dc.w      8                   item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 9

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      28                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB13-*          pointer to object
          dc.w      9                   item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 10

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      28                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB14-*          pointer to object
          dc.w      10                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 11

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      28                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB15-*          pointer to object
          dc.w      11                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 12

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      28                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB16-*          pointer to object
          dc.w      12                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 13

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      28                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB17-*          pointer to object
          dc.w      13                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 14

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      41                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB18-*          pointer to object
          dc.w      14                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 15

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      41                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB19-*          pointer to object
          dc.w      15                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 16

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      41                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB20-*          pointer to object
          dc.w      16                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 17

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      41                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB21-*          pointer to object
          dc.w      17                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 18

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      41                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB22-*          pointer to object
          dc.w      18                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 19

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      41                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB23-*          pointer to object
          dc.w      19                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 20

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      41                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB24-*          pointer to object
          dc.w      20                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 21

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      54                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB25-*          pointer to object
          dc.w      21                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 22

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      54                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB26-*          pointer to object
          dc.w      22                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 23

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      54                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB27-*          pointer to object
          dc.w      23                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 24

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      54                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB28-*          pointer to object
          dc.w      24                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 25

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      54                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB29-*          pointer to object
          dc.w      25                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 26

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      54                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB30-*          pointer to object
          dc.w      26                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 27

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      54                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB31-*          pointer to object
          dc.w      27                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 28

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      67                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB32-*          pointer to object
          dc.w      28                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 29

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      67                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB33-*          pointer to object
          dc.w      29                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 30

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      67                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB34-*          pointer to object
          dc.w      30                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 31

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      67                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB35-*          pointer to object
          dc.w      31                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 32

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      67                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB36-*          pointer to object
          dc.w      32                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 33

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      67                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB37-*          pointer to object
          dc.w      33                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 34

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      67                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB38-*          pointer to object
          dc.w      34                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 35

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      80                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB39-*          pointer to object
          dc.w      35                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 36

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      80                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB40-*          pointer to object
          dc.w      36                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 37

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      80                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB41-*          pointer to object
          dc.w      37                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 38

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      80                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB42-*          pointer to object
          dc.w      38                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 39

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      80                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB43-*          pointer to object
          dc.w      39                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 40

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      80                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB44-*          pointer to object
          dc.w      40                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 41

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      80                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB45-*          pointer to object
          dc.w      41                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 42

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      93                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB46-*          pointer to object
          dc.w      42                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 43

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      93                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB47-*          pointer to object
          dc.w      43                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 44

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      93                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB48-*          pointer to object
          dc.w      44                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 45

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      93                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB49-*          pointer to object
          dc.w      45                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 46

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      93                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB50-*          pointer to object
          dc.w      46                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 47

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      93                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB51-*          pointer to object
          dc.w      47                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 48

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      93                             y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB52-*          pointer to object
          dc.w      48                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 49

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      106                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB53-*          pointer to object
          dc.w      49                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 50

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      106                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB54-*          pointer to object
          dc.w      50                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 51

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      106                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB55-*          pointer to object
          dc.w      51                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 52

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      106                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB56-*          pointer to object
          dc.w      52                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 53

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      106                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB57-*          pointer to object
          dc.w      53                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 54

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      106                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB58-*          pointer to object
          dc.w      54                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 55

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      106                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB59-*          pointer to object
          dc.w      55                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 56

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      119                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB60-*          pointer to object
          dc.w      56                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 57

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      119                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB61-*          pointer to object
          dc.w      57                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 58

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      119                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB62-*          pointer to object
          dc.w      58                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 59

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      119                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB63-*          pointer to object
          dc.w      59                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 60

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      119                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB64-*          pointer to object
          dc.w      60                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 61

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      119                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB65-*          pointer to object
          dc.w      61                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 62

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      119                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB66-*          pointer to object
          dc.w      62                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 63

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      132                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB67-*          pointer to object
          dc.w      63                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 64

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      132                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB68-*          pointer to object
          dc.w      64                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 65

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      132                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB69-*          pointer to object
          dc.w      65                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 66

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      132                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB70-*          pointer to object
          dc.w      66                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 67

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      132                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB71-*          pointer to object
          dc.w      67                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 68

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      132                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB72-*          pointer to object
          dc.w      68                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 69

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      132                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB73-*          pointer to object
          dc.w      69                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 70

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      145                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB74-*          pointer to object
          dc.w      70                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 71

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      145                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB75-*          pointer to object
          dc.w      71                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 72

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      145                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB76-*          pointer to object
          dc.w      72                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 73

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      145                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB77-*          pointer to object
          dc.w      73                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 74

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      145                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB78-*          pointer to object
          dc.w      74                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 75

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      145                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB79-*          pointer to object
          dc.w      75                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 76

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      145                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB80-*          pointer to object
          dc.w      76                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 77

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      158                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB81-*          pointer to object
          dc.w      77                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 78

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      158                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB82-*          pointer to object
          dc.w      78                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 79

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      158                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB83-*          pointer to object
          dc.w      79                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 80

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      158                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB84-*          pointer to object
          dc.w      80                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 81

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      158                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB85-*          pointer to object
          dc.w      81                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 82

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      158                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB86-*          pointer to object
          dc.w      82                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 83

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      158                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB87-*          pointer to object
          dc.w      83                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 84

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      171                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB88-*          pointer to object
          dc.w      84                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 85

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      171                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB89-*          pointer to object
          dc.w      85                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 86

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      171                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB90-*          pointer to object
          dc.w      86                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 87

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      171                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB90-*          pointer to object
          dc.w      87                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 88

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      171                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB92-*          pointer to object
          dc.w      88                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 89

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      171                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB93-*          pointer to object
          dc.w      89                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 90

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      171                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB94-*          pointer to object
          dc.w      90                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 91

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      184                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB95-*          pointer to object
          dc.w      91                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 92

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      184                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB96-*          pointer to object
          dc.w      92                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 93

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      184                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB97-*          pointer to object
          dc.w      93                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 94

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      184                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB98-*          pointer to object
          dc.w      94                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 95

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      184                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB99-*          pointer to object
          dc.w      95                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 96

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      184                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB100-*         pointer to object
          dc.w      96                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 97

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      184                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB101-*         pointer to object
          dc.w      97                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 98

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      197                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB102-*         pointer to object
          dc.w      98                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 99

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      197                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB103-*         pointer to object
          dc.w      99                  item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 100

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      197                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB104-*         pointer to object
          dc.w      100                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 101

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      197                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB105-*         pointer to object
          dc.w      101                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 102

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      197                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB106-*         pointer to object
          dc.w      102                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 103

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      197                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB107-*         pointer to object
          dc.w      103                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 104

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      197                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB108-*         pointer to object
          dc.w      104                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 105

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      210                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB109-*         pointer to object
          dc.w      105                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 106

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      210                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB110-*         pointer to object
          dc.w      106                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 107

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      210                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB111-*         pointer to object
          dc.w      107                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 108

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      210                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB112-*         pointer to object
          dc.w      108                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 109

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      210                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB113-*         pointer to object
          dc.w      109                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 110

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      210                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB114-*         pointer to object
          dc.w      110                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 111

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      210                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB115-*         pointer to object
          dc.w      111                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 112

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      223                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB116-*         pointer to object
          dc.w      112                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 113

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      72                             x origin
          dc.w      223                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB117-*         pointer to object
          dc.w      113                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 114

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      138                            x origin
          dc.w      223                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB118-*         pointer to object
          dc.w      114                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 115

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      204                            x origin
          dc.w      223                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB119-*         pointer to object
          dc.w      115                 item number
          dc.w      LI_NAME-*           pointer to action routine


* Loose menu item n 116

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      270                            x origin
          dc.w      223                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB120-*         pointer to object
          dc.w      116                 item number
          dc.w      LI_NAME-*           pointer to action routine


* Loose menu item n 117

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      223                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      VAR_OB121-*         pointer to object
          dc.w      117                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 118

          dc.w      64                  hit area   x size
          dc.w      12                             y size
          dc.w      402                            x origin
          dc.w      223                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      '%'                 selection keystroke
          dc.w      VAR_OB122-*         pointer to object
          dc.w      118                 item number
          dc.w      LI_NAME-*           pointer to action routine

* Loose menu item n 119

          dc.w      52                  hit area   x size
          dc.w      12                             y size
          dc.w      336                            x origin
          dc.w      236                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'T'                 selection keystroke
          dc.w      VAR_OB123-*         pointer to object
          dc.w      119                 item number
          dc.w      TRUEFALSE-*         pointer to action routine

* Loose menu item n 120

          dc.w      52                  hit area   x size
          dc.w      12                             y size
          dc.w      414                            x origin
          dc.w      236                            y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'F'                 selection keystroke
          dc.w      VAR_OB124-*         pointer to object
          dc.w      120                 item number
          dc.w      TRUEFALSE-*         pointer to action routine

* Loose menu item n 121

          dc.w      24                  hit area   x size
          dc.w      10                             y size
          dc.w      444                            x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      3                   selection keystroke
          dc.w      ESC_OBJ-*           pointer to object
          dc.w      121                 item number
          dc.w      EVENT0-*            pointer to action routine

* Loose menu item n 110

          dc.w      24                  hit area   x size
          dc.w      10                             y size
          dc.w      4                              x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      5                   selection keystroke
          dc.w      MOVE_SPR-*          pointer to object
          dc.w      122                 item number
          dc.w      EVENT-*             pointer to action routine

          dc.w      -1                  end flag

* Object list:
* ~~~~~~~~~~~

* Object n 1

VAR_OB1   dc.w      52
          dc.b      'Variables with an underlined "$" are flags accepting'

* Object n 2

VAR_OB2   dc.w      2
          dc.b      'or'

* Object n 3

VAR_OB3   dc.w      9
          dc.b      'Variables',0

* Object n 4

VAR_OB4   dc.w      7
          dc.b      '$abbell',0

* Object n 5

VAR_OB5   dc.w      6
          dc.b      '$abcap'

* Object n 6

VAR_OB6   dc.w      8
          dc.b      '$abquick'

* Object n 7

VAR_OB7   dc.w      7
          dc.b      '$acount',0

* Object n 8

VAR_OB8   dc.w      6
          dc.b      '$asave'

* Object n 9

VAR_OB9   dc.w      8
          dc.b      '$bufhook'

* Object n 10

VAR_OB10  dc.w      8
          dc.b      '$cbflags'

* Object n 11

VAR_OB11  dc.w      9
          dc.b      '$cbufname',0

* Object n 12

VAR_OB12  dc.w      7
          dc.b      '$cfname',0

* Object n 13

VAR_OB13  dc.w      8
          dc.b      '$cmdhook'

* Object n 14

VAR_OB14  dc.w      6
          dc.b      '$cmode'

* Object n 15

VAR_OB15  dc.w      8
          dc.b      '$curchar'

* Object n 16

VAR_OB16  dc.w      7
          dc.b      '$curcol',0

* Object n 17

VAR_OB17  dc.w      8
          dc.b      '$curline'

* Object n 18

VAR_OB18  dc.w      9
          dc.b      '$curwidth',0

* Object n 19

VAR_OB19  dc.w      8
          dc.b      '$curwind'

* Object n 20

VAR_OB20  dc.w      7
          dc.b      '$cwline',0

* Object n 21

VAR_OB21  dc.w      6
          dc.b      '$debug'

* Object n 22

VAR_OB22  dc.w      10
          dc.b      '$deskcolor'

* Object n 23

VAR_OB23  dc.w      9
          dc.b      '$diagflag',0

* Object n 24

VAR_OB24  dc.w      7
          dc.b      '$discmd',0

* Object n 25

VAR_OB25  dc.w      7
          dc.b      '$disinp',0

* Object n 26

VAR_OB26  dc.w      9
          dc.b      '$disphigh',0

* Object n 27

VAR_OB27  dc.w      9
          dc.b      '$dispundo',0

* Object n 28

VAR_OB28  dc.w      8
          dc.b      '$exbhook'

* Object n 29

VAR_OB29  dc.w      9
          dc.b      '$exithook',0

* Object n 30

VAR_OB30  dc.w      5
          dc.b      '$fcol',0

* Object n 31

VAR_OB31  dc.w      8
          dc.b      '$fillcol'

* Object n 32

VAR_OB32  dc.w      8
          dc.b      '$flicker'

* Object n 33

VAR_OB33  dc.w      8
          dc.b      '$fmtlead'

* Object n 34

VAR_OB34  dc.w      7
          dc.b      '$gflags',0

* Object n 35

VAR_OB35  dc.w      6
          dc.b      '$gmode'

* Object n 36

VAR_OB36  dc.w      8
          dc.b      '$hardtab'

* Object n 37

VAR_OB37  dc.w      8
          dc.b      '$hilight'

* Object n 38

VAR_OB38  dc.w      9
          dc.b      '$hilight1',0

* Object n 39

VAR_OB39  dc.w      9
          dc.b      '$hilight2',0

* Object n 40

VAR_OB40  dc.w      9
          dc.b      '$hilight3',0

* Object n 41

VAR_OB41  dc.w      9
          dc.b      '$hilight4',0

* Object n 42

VAR_OB42  dc.w      6
          dc.b      '$hjump'

* Object n 43

VAR_OB43  dc.w      8
          dc.b      '$hscroll'

* Object n 44

VAR_OB44  dc.w      7
          dc.b      '$isterm',0

* Object n 45

VAR_OB45  dc.w      5
          dc.b      '$kill',0

* Object n 46

VAR_OB46  dc.w      9
          dc.b      '$language',0

* Object n 47

VAR_OB47  dc.w      8
          dc.b      '$lastkey'

* Object n 48

VAR_OB48  dc.w      9
          dc.b      '$lastmesg',0

* Object n 49

VAR_OB49  dc.w      5
          dc.b      '$line',0

* Object n 50

VAR_OB50  dc.w      6
          dc.b      '$lterm'

* Object n 51

VAR_OB51  dc.w      7
          dc.b      '$lwidth',0

* Object n 52

VAR_OB52  dc.w      6
          dc.b      '$match'

* Object n 53

VAR_OB53  dc.w      6
          dc.b      '$mmove'

* Object n 54

VAR_OB54  dc.w      9
          dc.b      '$modeflag',0

* Object n 55

VAR_OB55  dc.w      7
          dc.b      '$msflag',0

* Object n 56

VAR_OB56  dc.w      10
          dc.b      '$newscreen'

* Object n 57

VAR_OB57  dc.w      8
          dc.b      '$numwind'

* Object n 58

VAR_OB58  dc.w      7
          dc.b      '$orgcol',0

* Object n 59

VAR_OB59  dc.w      7
          dc.b      '$orgrow',0

* Object n 60

VAR_OB60  dc.w      3
          dc.b      '$os',0

* Object n 61

VAR_OB61  dc.w      8
          dc.b      '$overlap'

* Object n 62

VAR_OB62  dc.w      8
          dc.b      '$pagelen'

* Object n 63

VAR_OB63  dc.w      8
          dc.b      '$palette'

* Object n 64

VAR_OB64  dc.w      9
          dc.b      '$paralead',0

* Object n 65

VAR_OB65  dc.w      8
          dc.b      '$pending'

* Object n 66

VAR_OB66  dc.w      8
          dc.b      '$popflag'

* Object n 67

VAR_OB67  dc.w      8
          dc.b      '$popwait'

* Object n 68

VAR_OB68  dc.w      8
          dc.b      '$posflag'

* Object n 69

VAR_OB69  dc.w      9
          dc.b      '$progname',0

* Object n 70

VAR_OB70  dc.w      4
          dc.b      '$ram'

* Object n 71

VAR_OB71  dc.w      9
          dc.b      '$readhook',0

* Object n 72

VAR_OB72  dc.w      7
          dc.b      '$region',0

* Object n 73

VAR_OB73  dc.w      8
          dc.b      '$replace'

* Object n 74

VAR_OB74  dc.w      5
          dc.b      '$rval',0

* Object n 75

VAR_OB75  dc.w      8
          dc.b      '$scrname'

* Object n 76

VAR_OB76  dc.w      7
          dc.b      '$search',0

* Object n 77

VAR_OB77  dc.w      10
          dc.b      '$searchpnt'

* Object n 78

VAR_OB78  dc.w      5
          dc.b      '$seed',0

* Object n 79

VAR_OB79  dc.w      8
          dc.b      '$shlhook'

* Object n 80

VAR_OB80  dc.w      8
          dc.b      '$softtab'

* Object n 81

VAR_OB81  dc.w      5
          dc.b      '$sres',0

* Object n 82

VAR_OB82  dc.w      6
          dc.b      '$ssave'

* Object n 83

VAR_OB83  dc.w      8
          dc.b      '$sscroll'

* Object n 84

VAR_OB84  dc.w      7
          dc.b      '$status',0

* Object n 85

VAR_OB85  dc.w      6
          dc.b      '$sterm'

* Object n 86

VAR_OB86  dc.w      7
          dc.b      '$syntax',0

* Object n 87

VAR_OB87  dc.w      7
          dc.b      '$target',0

* Object n 88

VAR_OB88  dc.w      5
          dc.b      '$time',0

* Object n 89

VAR_OB89  dc.w      9
          dc.b      '$timeflag',0

* Object n 90

VAR_OB90  dc.w      7
          dc.b      '$tpause',0

* Object n 91

VAR_OB91  dc.w      9
          dc.b      '$undoflag',0

* Object n 92

VAR_OB92  dc.w      8
          dc.b      '$version'

* Object n 93

VAR_OB93  dc.w      9
          dc.b      '$vscrlbar',0

* Object n 94

VAR_OB94  dc.w      7
          dc.b      '$wchars',0

* Object n 95

VAR_OB95  dc.w      6
          dc.b      '$wline'

* Object n 96

VAR_OB96  dc.w      9
          dc.b      '$wraphook',0

* Object n 97

VAR_OB97  dc.w      10
          dc.b      '$writehook'

* Object n 98

VAR_OB98  dc.w      5
          dc.b      '$xpos',0

* Object n 99

VAR_OB99  dc.w      9
          dc.b      '$yankflag',0

* Object n 100

VAR_OB100 dc.w      5
          dc.b      '$ypos',0

* Object n 101

VAR_OB101 dc.w      6
          dc.b      '$beep'

* Object n 102

VAR_OB102 dc.w      9
          dc.b      '$boldoff',0

* Object n 103

VAR_OB103 dc.w      8
          dc.b      '$boldon'

* Object n 104

VAR_OB104 dc.w      8
          dc.b      '$cmdink'

* Object n 105

VAR_OB105 dc.w      10
          dc.b      '$cmdpaper'

* Object n 106

VAR_OB106 dc.w      6
          dc.b      '$crlf'

* Object n 107

VAR_OB107 dc.w      10
          dc.b      '$dictfile'

* Object n 108

VAR_OB108 dc.w      10
          dc.b      '$duration'

* Object n 109

VAR_OB109 dc.w      9
          dc.b      '$italoff',0

* Object n 110

VAR_OB110 dc.w      8
          dc.b      '$italon'

* Object n 111

VAR_OB111 dc.w      7
          dc.b      '$mlink',0

* Object n 112

VAR_OB112 dc.w      9
          dc.b      '$mlpaper',0

* Object n 113

VAR_OB113 dc.w      10
          dc.b      '$pageflag'

* Object n 114

VAR_OB114 dc.w      10
          dc.b      '$pagesize'

* Object n 115

VAR_OB115 dc.w      7
          dc.b      '$pitch',0

* Object n 116

VAR_OB116 dc.w      9
          dc.b      '$printer',0

* Object n 117

VAR_OB117 dc.w      9
          dc.b      '$prtinit',0

* Object n 118

VAR_OB118 dc.w      7
          dc.b      '$title',0

* Object n 119

VAR_OB119 dc.w      10
          dc.b      '$translat'

* Object n 120

VAR_OB120 dc.w      10
          dc.b      '$underoff'

* Object n 121

VAR_OB121 dc.w      9
          dc.b      '$underon',0

* Object n 122

VAR_OB122 dc.w      4
          dc.b      '%...'

* Object n 123

VAR_OB123 dc.w      4
          dc.b      'TRUE'

* Object n 124

VAR_OB124 dc.w      5
          dc.b      'FALSE',0

********************************************************************************
* Sous-menu "Commandes":
* ~~~~~~~~~~~~~~~~~~~~~

          dc.w      18                  Numro du loose item "stick/unstick".

          dc.w      COM_CMDS-COMMANDE   Ptr vers table des ptr sur commandes.

COMMANDE  dc.l      $420                working definition length
          dc.l      $70                 status area length
          dc.b      0                   -1 no mode change, 0/8 force mode 4/8
          dc.b      0                   -1 absolute position, 0 pointer relative
          dc.w      0,0                 absolute initial position

* Main window definition:
* ~~~~~~~~~~~~~~~~~~~~~~

          dc.w      176                 default window x size
          dc.w      246                                y size
          dc.w      134                 initial pointer x position
          dc.w      3                                   y position
          dc.b      0                   MSbit clear to clear window
          dc.b      2                   shadow depth
          dc.w      1                   border width
          dc.w      7                   border colour
          dc.w      0                   paper colour
          dc.w      _hand_spr-*         pointer to pointer sprite

* Menu item attributes:

          dc.w      1                   current item border width
          dc.w      4                                border colour

* Menu item unavailable:

          dc.w      0                   background colour
          dc.w      2                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item available:

          dc.w      0                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item selected:

          dc.w      2                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

          dc.w      0                   pointer to help window

* Base of repeated part of window definition

          dc.w      176                 x (min.) size for this layout
          dc.w      246                 y (min.) size for this layout

* Pointers to definition lists:

          dc.w      COM_IL-*            information sub-windows
          dc.w      COM_LL-*            loose menu items
          dc.w      0                   application sub-windows

          dc.w      -1                  end flag

* Information sub-window definition list:
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

* Information sub-window n 0

COM_IL    dc.w      168                 sub-window x size
          dc.w      105                 sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      14                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      COM_OL0-*           pointer to information object list

* Information sub-window n 1

          dc.w      168                 sub-window x size
          dc.w      66                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      120                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      COM_OL1-*           pointer to information object list

* Information sub-window n 2

          dc.w      168                 sub-window x size
          dc.w      14                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      187                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      COM_OL2-*           pointer to information object list

* Information sub-window n 3

          dc.w      110                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      42                  sub-window x origin
          dc.w      1                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      100                 paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 4

          dc.w      52                  sub-window x size
          dc.w      13                  sub-window y size
          dc.w      58                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      COM_OL4-*           pointer to information object list

* Information sub-window n 5

          dc.w      168                 sub-window x size
          dc.w      27                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      202                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      COM_OL5-*           pointer to information object list

* Information sub-window n 6

          dc.w      168                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      232                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      COM_OL6-*           pointer to information object list

          dc.w      -1                  end flag

* Information sub-window n 0 object list:

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

COM_OL0   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      COM_OB1-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      COM_OB2-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      COM_OB3-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      COM_OB4-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      54                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      67                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      COM_OB6-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      80                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      COM_OB7-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      93                         y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      COM_OB8-*           pointer to object

          dc.w      -1                  end flag

* Information sub-window n 1 object list:

COM_OL1   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      COM_OB9-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      COM_OB10-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      COM_OB11-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      COM_OB12-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      54                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      COM_OB13-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 2 object list:

COM_OL2   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      COM_OB14-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 4 object list:

COM_OL4   dc.w      50                  object x size
          dc.w      10                         y size
          dc.w      2                          x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      COM_OB15-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 5 object list:

COM_OL5   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      -4                  object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 6 object list:

COM_OL6   dc.w      116                 object x size
          dc.w      10                         y size
          dc.w      2                          x origin
          dc.w      1                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      ARG_OBJ-*           pointer to object

          dc.w      -1                  end flag

* Loose menu item list:
* ~~~~~~~~~~~~~~~~~~~~

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern


* Loose menu item n 0

COM_LL    dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      15                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -15                 object type
          dc.b      'C'                 selection keystroke
          dc.w      COM_OB19-*          pointer to object
          dc.w      0                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 1

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      28                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -13                 object type
          dc.b      'O'                 selection keystroke
          dc.w      COM_OB20-*          pointer to object
          dc.w      1                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 2

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      41                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -10                 object type
          dc.b      'L'                 selection keystroke
          dc.w      COM_OB21-*          pointer to object
          dc.w      2                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 3

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      54                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -10                 object type
          dc.b      'F'                 selection keystroke
          dc.w      COM_OB22-*          pointer to object
          dc.w      3                   item number
          dc.w      SEND_FNAM-*         pointer to action routine

* Loose menu item n 4

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      67                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -6                  object type
          dc.b      'B'                 selection keystroke
          dc.w      COM_OB23-*          pointer to object
          dc.w      4                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 5

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      80                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'S'                 selection keystroke
          dc.w      COM_OB24-*          pointer to object
          dc.w      5                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 6

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      93                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'E'                 selection keystroke
          dc.w      COM_OB25-*          pointer to object
          dc.w      6                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 7

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      106                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -9                  object type
          dc.b      'M'                 selection keystroke
          dc.w      COM_OB26-*          pointer to object
          dc.w      7                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 8

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      121                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'R'                 selection keystroke
          dc.w      COM_OB27-*          pointer to object
          dc.w      8                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 9

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      134                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'P'                 selection keystroke
          dc.w      COM_OB28-*          pointer to object
          dc.w      9                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 10

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      147                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -4                  object type
          dc.b      'T'                 selection keystroke
          dc.w      COM_OB29-*          pointer to object
          dc.w      10                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 11

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      160                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -5                  object type
          dc.b      'U'                 selection keystroke
          dc.w      COM_OB30-*          pointer to object
          dc.w      11                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 12

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      173                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -9                  object type
          dc.b      'N'                 selection keystroke
          dc.w      COM_OB31-*          pointer to object
          dc.w      12                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 13

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      188                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -7                  object type
          dc.b      'I'                 selection keystroke
          dc.w      COM_OB32-*          pointer to object
          dc.w      13                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 14

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      203                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -10                 object type
          dc.b      'V'                 selection keystroke
          dc.w      COM_OB33-*          pointer to object
          dc.w      14                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 15

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      216                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      0                   selection keystroke
          dc.w      COM_OB34-*          pointer to object
          dc.w      15                  item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 16

          dc.w      18                  hit area   x size
          dc.w      10                             y size
          dc.w      154                            x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      3                   selection keystroke
          dc.w      ESC_OBJ-*           pointer to object
          dc.w      16                  item number
          dc.w      EVENT0-*            pointer to action routine

* Loose menu item n 17

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      4                              x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      5                   selection keystroke
          dc.w      MOVE_SPR-*          pointer to object
          dc.w      17                  item number
          dc.w      EVENT-*             pointer to action routine

* Loose menu item n 18

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      24                             x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      236                 selection keystroke
          dc.w      UNST_SPR-*          pointer to object
          dc.w      18                  item number
          dc.w      STICK-*             pointer to action routine

* Loose menu item n 19

          dc.w      44                  hit area   x size
          dc.w      10                             y size
          dc.w      126                            x origin
          dc.w      233                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      '.'                 selection keystroke
          dc.w      FAKE_ARG-*          pointer to object
          dc.w      19                  item number
          dc.w      CHANGE-*            pointer to action routine

          dc.w      -1                  end flag

COM_CMDS  dc.w      COM_CMD1-COM_CMDS
          dc.w      COM_CMD2-COM_CMDS
          dc.w      COM_CMD3-COM_CMDS
          dc.w      COM_CMD4-COM_CMDS
          dc.w      COM_CMD5-COM_CMDS
          dc.w      COM_CMD6-COM_CMDS
          dc.w      COM_CMD7-COM_CMDS
          dc.w      COM_CMD8-COM_CMDS
          dc.w      COM_CMD9-COM_CMDS
          dc.w      COM_CMD10-COM_CMDS
          dc.w      COM_CMD11-COM_CMDS
          dc.w      COM_CMD12-COM_CMDS
          dc.w      COM_CMD13-COM_CMDS
          dc.w      COM_CMD14-COM_CMDS
          dc.w      COM_CMD15-COM_CMDS
          dc.w      COM_CMD16-COM_CMDS

* Object list:
* ~~~~~~~~~~~

* Object n 1

COM_OB1   dc.w      4
          dc.b      'e. X'

COM_CMD1  dc.w      21
          dc.b      'execute-named-command',0

* Object n 2

COM_OB2   dc.w      4
          dc.b      'e.^E'

COM_CMD2  dc.w      3
          dc.b      'run',0

* Object n 3

COM_OB3   dc.w      4
          dc.b      'e.^X'

COM_CMD3  dc.w      20
          dc.b      'execute-command-line'

* Object n 4

COM_OB4   dc.w      4
          dc.b      'e.^S'

COM_CMD4  dc.w      12
          dc.b      'execute-file'

COM_CMD5  dc.w      14
          dc.b      'execute-buffer'

* Object n 6

COM_OB6   dc.w      4
          dc.b      '^X ('

COM_CMD6  dc.w      11
          dc.b      'begin-macro',0

* Object n 7

COM_OB7   dc.w      4
          dc.b      '^X )'

COM_CMD7  dc.w      9
          dc.b      'end-macro',0

* Object n 8

COM_OB8   dc.w      4
          dc.b      '^X E'

COM_CMD8  dc.w      13
          dc.b      'execute-macro',0

* Object n 9

COM_OB9   dc.w      4
          dc.b      '^X !'

COM_CMD9  dc.w      13
          dc.b      'shell-command',0

* Object n 10

COM_OB10  dc.w      4
          dc.b      '^X @'

COM_CMD10 dc.w      12
          dc.b      'pipe-command'

* Object n 11

COM_OB11  dc.w      4
          dc.b      '^X #'

COM_CMD11 dc.w      13
          dc.b      'filter-buffer',0

* Object n 12

COM_OB12  dc.w      4
          dc.b      '^X $'

COM_CMD12 dc.w      15
          dc.b      'execute-program',0

* Object n 13

COM_OB13  dc.w      4
          dc.b      '^X C'

COM_CMD13 dc.w      7
          dc.b      'i-shell',0

* Object n 14

COM_OB14  dc.w      4
          dc.b      '^X I'

COM_CMD14 dc.w      8
          dc.b      'fileinfo'

COM_CMD15 dc.w      12
          dc.b      'server-start'

COM_CMD16 dc.w      11
          dc.b      'server-stop',0

* Object n 15

COM_OB15  dc.w      8
          dc.b      'Commands'

* Object n 19

COM_OB19  dc.w      21
          dc.b      'Execute named command',0

* Object n 20

COM_OB20  dc.w      19
          dc.b      'Execute a procedure',0

* Object n 21

COM_OB21  dc.w      22
          dc.b      'Exec cmd line as macro'

* Object n 22

COM_OB22  dc.w      22
          dc.b      'Exec cmd file as macro'

* Object n 23

COM_OB23  dc.w      20
          dc.b      'Exec buffer as macro'

* Object n 24

COM_OB24  dc.w      21
          dc.b      'Start macro recording',0

* Object n 25

COM_OB25  dc.w      19
          dc.b      'End macro recording',0

* Object n 26

COM_OB26  dc.w      13
          dc.b      'Execute macro',0

* Object n 27

COM_OB27  dc.w      21
          dc.b      'Run one shell command',0

* Object n 28

COM_OB28  dc.w      22
          dc.b      'Pipe command to buffer'

* Object n 29

COM_OB29  dc.w      22
          dc.b      'Filter buffer thru cmd'

* Object n 30

COM_OB30  dc.w      17
          dc.b      'Execute a programme',0

* Object n 31

COM_OB31  dc.w      17
          dc.b      'Start a new shell',0

* Object n 32

COM_OB32  dc.w      16
          dc.b      'Call FileInfo II'

* Object n 33

COM_OB33  dc.w      12
          dc.b      'Start server'

* Object n 34

COM_OB34  dc.w      11
          dc.b      'Stop server',0

********************************************************************************
* Sous-menu "Aide":
* ~~~~~~~~~~~~~~~~

          dc.w      11                  Numro du loose item "stick/unstick".

          dc.w      AID_CMDS-AIDE       Ptr vers table des ptr sur commandes.

AIDE      dc.l      $300                working definition length
          dc.l      $60                 status area length
          dc.b      0                   -1 no mode change, 0/8 force mode 4/8
          dc.b      0                   -1 absolute position, 0 pointer relative
          dc.w      0,0                 absolute initial position

* Main window definition:
* ~~~~~~~~~~~~~~~~~~~~~~

          dc.w      176                 default window x size
          dc.w      154                                y size
          dc.w      134                 initial pointer x position
          dc.w      3                                   y position
          dc.b      0                   MSbit clear to clear window
          dc.b      2                   shadow depth
          dc.w      1                   border width
          dc.w      7                   border colour
          dc.w      0                   paper colour
          dc.w      _hand_spr-*         pointer to pointer sprite

* Menu item attributes:

          dc.w      1                   current item border width
          dc.w      4                                border colour

* Menu item unavailable:

          dc.w      0                   background colour
          dc.w      2                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item available:

          dc.w      0                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item selected:

          dc.w      2                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

          dc.w      0                   pointer to help window

* Base of repeated part of window definition

          dc.w      176                 x (min.) size for this layout
          dc.w      154                 y (min.) size for this layout

* Pointers to definition lists:

          dc.w      AID_IL-*            information sub-windows
          dc.w      AID_LL-*            loose menu items
          dc.w      0                   application sub-windows

          dc.w      -1                  end flag

* Information sub-window definition list:
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

* Information sub-window n 0

AID_IL    dc.w      168                 sub-window x size
          dc.w      14                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      14                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      AID_OL0-*           pointer to information object list

* Information sub-window n 1

          dc.w      168                 sub-window x size
          dc.w      53                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      29                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      AID_OL1-*           pointer to information object list

* Information sub-window n 2

          dc.w      168                 sub-window x size
          dc.w      53                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      99                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      AID_OL2-*           pointer to information object list

* Information sub-window n 3

          dc.w      110                 sub-window x size
          dc.w      13                  sub-window y size
          dc.w      42                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      100                 paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 4

          dc.w      32                  sub-window x size
          dc.w      12                  sub-window y size
          dc.w      68                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      AID_OL4-*           pointer to information object list

* Information sub-window n 5

          dc.w      176                 sub-window x size
          dc.w      2                   sub-window y size
          dc.w      0                   sub-window x origin
          dc.w      83                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      112                 paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 6

          dc.w      176                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      0                   sub-window x origin
          dc.w      85                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      96                  paper colour
          dc.w      0                   pointer to information object list

* Information sub-window n 7

          dc.w      56                  sub-window x size
          dc.w      12                  sub-window y size
          dc.w      60                  sub-window x origin
          dc.w      85                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      AID_OL7-*           pointer to information object list

          dc.w      -1                  end flag

* Information sub-window n 0 object list:

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

AID_OL0   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      AID_OB1-*           pointer to object

          dc.w      -1                  end flag

* Information sub-window n 1 object list:

AID_OL1   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      AID_OB2-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 2 object list:

AID_OL2   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      AID_OB6-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      AID_OB7-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      AID_OB8-*           pointer to object

          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      AID_OB9-*           pointer to object

          dc.w      -1                  end flag

* Information sub-window n 4 object list:

AID_OL4   dc.w      24                  object x size
          dc.w      10                         y size
          dc.w      4                          x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      AID_OB10-*          pointer to object

          dc.w      -1                  end flag

* Information sub-window n 7 object list:

AID_OL7   dc.w      50                  object x size
          dc.w      10                         y size
          dc.w      4                          x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      AID_OB11-*          pointer to object

          dc.w      -1                  end flag

* Loose menu item list:
* ~~~~~~~~~~~~~~~~~~~~

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern


* Loose menu item n 0

AID_LL    dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      15                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'H'                 selection keystroke
          dc.w      AID_OB12-*          pointer to object
          dc.w      0                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 1

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      30                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'A'                 selection keystroke
          dc.w      AID_OB13-*          pointer to object
          dc.w      1                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 2

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      43                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -10                 object type
          dc.b      'C'                 selection keystroke
          dc.w      AID_OB14-*          pointer to object
          dc.w      2                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 3

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      56                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -10                 object type
          dc.b      'F'                 selection keystroke
          dc.w      AID_OB15-*          pointer to object
          dc.w      3                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 4

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      69                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -10                 object type
          dc.b      'V'                 selection keystroke
          dc.w      AID_OB16-*          pointer to object
          dc.w      4                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 5

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      100                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -12                 object type
          dc.b      'K'                 selection keystroke
          dc.w      AID_OB17-*          pointer to object
          dc.w      5                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 6

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      113                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -14                 object type
          dc.b      'B'                 selection keystroke
          dc.w      AID_OB18-*          pointer to object
          dc.w      6                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 7

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      126                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'D'                 selection keystroke
          dc.w      AID_OB19-*          pointer to object
          dc.w      7                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 8

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      139                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -6                  object type
          dc.b      'M'                 selection keystroke
          dc.w      AID_OB20-*          pointer to object
          dc.w      8                   item number
          dc.w      SEND_CMD-*          pointer to action routine

* Loose menu item n 9

          dc.w      18                  hit area   x size
          dc.w      10                             y size
          dc.w      154                            x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      3                   selection keystroke
          dc.w      ESC_OBJ-*           pointer to object
          dc.w      9                   item number
          dc.w      EVENT0-*            pointer to action routine

* Loose menu item n 10

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      4                              x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      5                   selection keystroke
          dc.w      MOVE_SPR-*          pointer to object
          dc.w      10                  item number
          dc.w      EVENT-*             pointer to action routine

* Loose menu item n 11

          dc.w      16                  hit area   x size
          dc.w      10                             y size
          dc.w      24                             x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      236                 selection keystroke
          dc.w      UNST_SPR-*          pointer to object
          dc.w      11                  item number
          dc.w      STICK-*             pointer to action routine

          dc.w      -1                  end flag

AID_CMDS  dc.w      AID_CMD1-AID_CMDS
          dc.w      AID_CMD2-AID_CMDS
          dc.w      AID_CMD3-AID_CMDS
          dc.w      AID_CMD4-AID_CMDS
          dc.w      AID_CMD5-AID_CMDS
          dc.w      AID_CMD6-AID_CMDS
          dc.w      AID_CMD7-AID_CMDS
          dc.w      AID_CMD8-AID_CMDS
          dc.w      AID_CMD9-AID_CMDS

* Object list:
* ~~~~~~~~~~~

* Object n 1

AID_OB1   dc.w      4
          dc.b      'e. ?'

AID_CMD1  dc.w      4
          dc.b      'help'

* Object n 2

AID_OB2   dc.w      4
          dc.b      'e. A'

AID_CMD2  dc.w      7
          dc.b      'apropos',0

AID_CMD3  dc.w      17
          dc.b      'describe-bindings',0

AID_CMD4  dc.w      18
          dc.b      'describe-functions'

AID_CMD5  dc.w      18
          dc.b      'describe-variables'

* Object n 6

AID_OB6   dc.w      4
          dc.b      '^X ?'

AID_CMD6  dc.w      12
          dc.b      'describe-key'

* Object n 7

AID_OB7   dc.w      4
          dc.b      'e. K'

AID_CMD7  dc.w      11
          dc.b      'bind-to-key',0

* Object n 8

AID_OB8   dc.w      4
          dc.b      'e.^K'

AID_CMD8  dc.w      10
          dc.b      'unbind-key'

* Object n 9

AID_OB9   dc.w      4
          dc.b      '^X^K'

AID_CMD9  dc.w      12
          dc.b      'macro-to-key'

* Object n 10

AID_OB10  dc.w      4
          dc.b      'Help'

* Object n 11

AID_OB11  dc.w      8
          dc.b      'Bindings'

* Object n 12

AID_OB12  dc.w      17
          dc.b      'Help on this port',0

* Object n 13

AID_OB13  dc.w      22
          dc.b      'Apropos commands/proc.'

* Object n 14

AID_OB14  dc.w      17
          dc.b      'List all commands',0

* Object n 15

AID_OB15  dc.w      18
          dc.b      'List all functions'

* Object n 16

AID_OB16  dc.w      18
          dc.b      'List all variables'

* Object n 17

AID_OB17  dc.w      22
          dc.b      'Describe a key binding'

* Object n 18

AID_OB18  dc.w      20
          dc.b      'Define a new binding'

* Object n 19

AID_OB19  dc.w      16
          dc.b      'Delete a binding'

* Object n 20

AID_OB20  dc.w      17
          dc.b      'Bind macro to key',0

********************************************************************************
* Sous-menu "Context":
* ~~~~~~~~~~~~~~~~~~~~

          dc.w      -1                  Numro du loose item "stick/unstick".

          dc.w      CON_CMDS-CONTEXT    Ptr vers table des ptr sur commandes.

CONTEXT   dc.l      $430                working definition length
          dc.l      $60                 status area length
          dc.b      0                   -1 no mode change, 0/8 force mode 4/8
          dc.b      0                   -1 absolute position, 0 pointer relative
          dc.w      0,0                 absolute initial position

* Main window definition:
* ~~~~~~~~~~~~~~~~~~~~~~

          dc.w      176                 default window x size
          dc.w      248                                y size
          dc.w      135                 initial pointer x position
          dc.w      3                                   y position
          dc.b      0                   MSbit clear to clear window
          dc.b      2                   shadow depth
          dc.w      1                   border width
          dc.w      7                   border colour
          dc.w      0                   paper colour
          dc.w      _hand_spr-*         pointer to pointer sprite

* Menu item attributes:

          dc.w      1                   current item border width
          dc.w      4                                border colour

* Menu item unavailable:

          dc.w      0                   background colour
          dc.w      2                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item available:

          dc.w      0                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob

* Menu item selected:

          dc.w      2                   background colour
          dc.w      7                   text object ink colour
          dc.w      0                   pointer to blob for pattern
          dc.w      0                   pointer to pattern for blob
  
          dc.w      0                   pointer to help window

* Base of repeated part of window definition:

          dc.w      176                 x (min.) size for this layout
          dc.w      248                 y (min.) size for this layout

* Pointers to definition lists:

          dc.w      CON_IL-*            information sub-windows
          dc.w      CON_LL-*            loose menu items
          dc.w      0                   application sub-windows
  
          dc.w      -1                  end flag
  
* Information sub-window definition list:
* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

* Information sub-window n 0

CON_IL    dc.w      168                 sub-window x size
          dc.w      79                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      14                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      CON_OL0-*           pointer to information object list
  
* Information sub-window n 1

          dc.w      168                 sub-window x size
          dc.w      66                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      110                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      CON_OL1-*           pointer to information object list
  
* Information sub-window n 2

          dc.w      168                 sub-window x size
          dc.w      53                  sub-window y size
          dc.w      4                   sub-window x origin
          dc.w      193                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      1                   border width
          dc.w      2                   border colour
          dc.w      0                   paper colour
          dc.w      CON_OL2-*           pointer to information object list
  
* Information sub-window n 3

          dc.w      128                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      24                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      100                 paper colour
          dc.w      0                   pointer to information object list
  
* Information sub-window n 4

          dc.w      44                  sub-window x size
          dc.w      12                  sub-window y size
          dc.w      66                  sub-window x origin
          dc.w      0                   sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      CON_OL4-*           pointer to information object list
  
* Information sub-window n 5

          dc.w      176                 sub-window x size
          dc.w      2                   sub-window y size
          dc.w      0                   sub-window x origin
          dc.w      94                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      118                 paper colour
          dc.w      0                   pointer to information object list
  
* Information sub-window n 6

          dc.w      176                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      0                   sub-window x origin
          dc.w      96                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      100                 paper colour
          dc.w      0                   pointer to information object list
  
* Information sub-window n 7

          dc.w      32                  sub-window x size
          dc.w      12                  sub-window y size
          dc.w      72                  sub-window x origin
          dc.w      96                  sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      CON_OL7-*           pointer to information object list
  
* Information sub-window n 8

          dc.w      176                 sub-window x size
          dc.w      2                   sub-window y size
          dc.w      0                   sub-window x origin
          dc.w      178                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      120                 paper colour
          dc.w      0                   pointer to information object list
  
* Information sub-window n 9

          dc.w      176                 sub-window x size
          dc.w      12                  sub-window y size
          dc.w      0                   sub-window x origin
          dc.w      180                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      96                  paper colour
          dc.w      0                   pointer to information object list
  
* Information sub-window n 10

          dc.w      88                  sub-window x size
          dc.w      12                  sub-window y size
          dc.w      44                  sub-window x origin
          dc.w      179                 sub-window y origin
          dc.b      0                   MSbit clear to clear window
          dc.b      0                   shadow depth
          dc.w      0                   border width
          dc.w      0                   border colour
          dc.w      0                   paper colour
          dc.w      CON_OL10-*          pointer to information object list
  
          dc.w      -1                  end flag
  
* Information sub-window n 0 object list :

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

CON_OL0   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object
  
          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      CON_OB2-*           pointer to object
  
          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      CON_OB3-*           pointer to object
  
          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      CON_OB4-*           pointer to object
  
          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      53                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object
  
          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      67                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object
  
          dc.w      -1                  end flag
  
* Information sub-window n 1 object list:

CON_OL1   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object
  
          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object
  
          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object
  
          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object
  
          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      54                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object
  
          dc.w      -1                  end flag
  
* Information sub-window n 2 object list:

CON_OL2   dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object
  
          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      15                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object
  
          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      28                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object
  
          dc.w      28                  object x size
          dc.w      12                         y size
          dc.w      140                        x origin
          dc.w      41                         y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      4                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      NONE_OBJ-*          pointer to object
  
          dc.w      -1                  end flag
  
* Information sub-window n 4 object list:

CON_OL4   dc.w      38                  object x size
          dc.w      10                         y size
          dc.w      4                          x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      CON_OB16-*          pointer to object
  
          dc.w      -1                  end flag
  
* Information sub-window n 7 object list:

CON_OL7   dc.w      24                  object x size
          dc.w      10                         y size
          dc.w      4                          x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      CON_OB17-*          pointer to object
  
          dc.w      -1                  end flag
  
* Information sub-window n 10 object list:

CON_OL10  dc.w      82                  object x size
          dc.w      10                         y size
          dc.w      4                          x origin
          dc.w      2                          y origin
          dc.b      0                   object type
          dc.b      0                   spare
          dc.w      7                   text ink colour
          dc.b      0                   text character x size
          dc.b      0                   text character y size
          dc.w      CON_OB18-*          pointer to object
  
          dc.w      -1                  end flag
  
* Loose menu item list:
* ~~~~~~~~~~~~~~~~~~~~~

* object type: <0  text, underline -type'th character
*              =0  text, no underline
*              =2  sprite
*              =4  blob
*              =6  pattern

* Loose menu item n 0

CON_LL    dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      15                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'S'                 selection keystroke
          dc.w      CON_OB19-*          pointer to object
          dc.w      0                   item number
          dc.w      SEND_CMD-*          pointer to action routine
  
* Loose menu item n 1

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      28                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'C'                 selection keystroke
          dc.w      CON_OB20-*          pointer to object
          dc.w      1                   item number
          dc.w      SEND_CMD-*          pointer to action routine
  
* Loose menu item n 2

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      41                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'M'                 selection keystroke
          dc.w      CON_OB21-*          pointer to object
          dc.w      2                   item number
          dc.w      SEND_CMD-*          pointer to action routine
  
* Loose menu item n 3

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      54                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'P'                 selection keystroke
          dc.w      CON_OB22-*          pointer to object
          dc.w      3                   item number
          dc.w      SEND_CMD-*          pointer to action routine
  
* Loose menu item n 4

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      67                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -11                 object type
          dc.b      'R'                 selection keystroke
          dc.w      CON_OB23-*          pointer to object
          dc.w      4                   item number
          dc.w      SEND_CMD-*          pointer to action routine
  
* Loose menu item n 5

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      80                             y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'I'                 selection keystroke
          dc.w      CON_OB24-*          pointer to object
          dc.w      5                   item number
          dc.w      SEND_CMD-*          pointer to action routine
  
* Loose menu item n 6

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      111                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -13                 object type
          dc.b      'W'                 selection keystroke
          dc.w      CON_OB25-*          pointer to object
          dc.w      6                   item number
          dc.w      SEND_CMD-*          pointer to action routine
  
* Loose menu item n 7

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      124                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -12                 object type
          dc.b      'K'                 selection keystroke
          dc.w      CON_OB26-*          pointer to object
          dc.w      7                   item number
          dc.w      SEND_CMD-*          pointer to action routine
  
* Loose menu item n 8

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      137                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -11                 object type
          dc.b      'N'                 selection keystroke
          dc.w      CON_OB27-*          pointer to object
          dc.w      8                   item number
          dc.w      SEND_CMD-*          pointer to action routine
  
* Loose menu item n 9

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      150                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -5                  object type
          dc.b      'E'                 selection keystroke
          dc.w      CON_OB28-*          pointer to object
          dc.w      9                   item number
          dc.w      SEND_CMD-*          pointer to action routine
  
* Loose menu item n 10

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      163                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -1                  object type
          dc.b      'T'                 selection keystroke
          dc.w      CON_OB29-*          pointer to object
          dc.w      10                  item number
          dc.w      SEND_CMD-*          pointer to action routine
  
* Loose menu item n 11

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      194                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -8                  object type
          dc.b      'H'                 selection keystroke
          dc.w      CON_OB30-*          pointer to object
          dc.w      11                  item number
          dc.w      SEND_CMD-*          pointer to action routine
  
* Loose menu item n 12

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      207                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -8                  object type
          dc.b      'A'                 selection keystroke
          dc.w      CON_OB31-*          pointer to object
          dc.w      12                  item number
          dc.w      SEND_CMD-*          pointer to action routine
  
* Loose menu item n 13

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      220                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -8                  object type
          dc.b      'F'                 selection keystroke
          dc.w      CON_OB32-*          pointer to object
          dc.w      13                  item number
          dc.w      SEND_CMD-*          pointer to action routine
  
* Loose menu item n 14

          dc.w      134                 hit area   x size
          dc.w      12                             y size
          dc.w      6                              x origin
          dc.w      233                            y origin
          dc.b      1                   object x justification
          dc.b      0                   object y justification
          dc.b      -6                  object type
          dc.b      'L'                 selection keystroke
          dc.w      CON_OB33-*          pointer to object
          dc.w      14                  item number
          dc.w      SEND_CMD-*          pointer to action routine
  
* Loose menu item n 15

          dc.w      18                  hit area   x size
          dc.w      10                             y size
          dc.w      154                            x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      0                   object type
          dc.b      3                   selection keystroke
          dc.w      ESC_OBJ-*           pointer to object
          dc.w      15                  item number
          dc.w      EVENT-*             pointer to action routine
  
* Loose menu item n 16

          dc.w      18                  hit area   x size
          dc.w      10                             y size
          dc.w      4                              x origin
          dc.w      2                              y origin
          dc.b      0                   object x justification
          dc.b      0                   object y justification
          dc.b      2                   object type
          dc.b      5                   selection keystroke
          dc.w      MOVE_SPR-*          pointer to object
          dc.w      16                  item number
          dc.w      EVENT-*             pointer to action routine
  
          dc.w      -1                  end flag
  
CON_CMDS  dc.w      CON_CMD1-CON_CMDS
          dc.w      CON_CMD2-CON_CMDS
          dc.w      CON_CMD3-CON_CMDS
          dc.w      CON_CMD4-CON_CMDS
          dc.w      CON_CMD5-CON_CMDS
          dc.w      CON_CMD6-CON_CMDS
          dc.w      CON_CMD7-CON_CMDS
          dc.w      CON_CMD8-CON_CMDS
          dc.w      CON_CMD9-CON_CMDS
          dc.w      CON_CMD10-CON_CMDS
          dc.w      CON_CMD11-CON_CMDS
          dc.w      CON_CMD12-CON_CMDS
          dc.w      CON_CMD13-CON_CMDS
          dc.w      CON_CMD14-CON_CMDS
          dc.w      CON_CMD15-CON_CMDS

* Object list:
* ~~~~~~~~~~~~

CON_CMD1  dc.w      31
          dc.b      'execute-command-line 0 set-mark',0

* Object n 2

CON_OB2   dc.w      4
          dc.b      'e. W'

CON_CMD2  dc.w      11
          dc.b      'copy-region',0

* Object n 3

CON_OB3   dc.w      4
          dc.b      '  ^W'

CON_CMD3  dc.w      11
          dc.b      'kill-region',0

* Object n 4

CON_OB4   dc.w      4
          dc.b      '  ^Y'

CON_CMD4  dc.w      4
          dc.b      'yank'

CON_CMD5  dc.w      15
          dc.b      'region-to-scrap',0

CON_CMD6  dc.w      12
          dc.b      'insert-scrap'

CON_CMD7  dc.w      11
          dc.b      'select-word',0

CON_CMD8  dc.w      35
          dc.b      'execute-command-line -1 select-word',0

CON_CMD9  dc.w      11
          dc.b      'search-word',0

CON_CMD10 dc.w      35
          dc.b      'execute-command-line -1 search-word',0

CON_CMD11 dc.w      8
          dc.b      'tag-word'

CON_CMD12 dc.w      11
          dc.b      'spell-check',0

CON_CMD13 dc.w      17
          dc.b      'qmenu-char-select',0

CON_CMD14 dc.w      15
          dc.b      'select-filename',0

CON_CMD15 dc.w      86
          dc.b      'execute-command-line 1 select-filename',13,0
          dc.b      27,'X','execute-command-line -1 fileinfo $search ""'

* Object n 16

CON_OB16  dc.w      6
          dc.b      'Region'

* Object n 17

CON_OB17  dc.w      4
          dc.b      'Word'

* Object n 18

CON_OB18  dc.w      13
          dc.b      'Miscellaneous',0

* Object n 19

CON_OB19  dc.w      10
          dc.b      'Set mark 0'

* Object n 20

CON_OB20  dc.w      19
          dc.b      'Copy to kill buffer',0

* Object n 21

CON_OB21  dc.w      19
          dc.b      'Move to kill buffer',0

* Object n 22

CON_OB22  dc.w      22
          dc.b      'Paste from kill buffer'

* Object n 23

CON_OB23  dc.w      13
          dc.b      'Copy to scrap',0

* Object n 24

CON_OB24  dc.w      12
          dc.b      'Insert scrap'

* Object n 25

CON_OB25  dc.w      22
          dc.b      'Select this word & ...'

* Object n 26

CON_OB26  dc.w      22
          dc.b      '...copy to kill buffer'

* Object n 27

CON_OB27  dc.w      18
          dc.b      '...search next one'

* Object n 28

CON_OB28  dc.w      22
          dc.b      '...search previous one'

* Object n 29

CON_OB29  dc.w      13
          dc.b      'Tag this word',0

* Object n 30

CON_OB30  dc.w      21
          dc.b      'Spell check from here',0

* Object n 31

CON_OB31  dc.w      18
          dc.b      'Insert a character'

* Object n 32

CON_OB32  dc.w      21
          dc.b      'Select filename & ...',0

* Object n 33
CON_OB33  dc.w      19
          dc.b      '...call FileInfo II',0

********************************************************************************
* Objets communs:
* ~~~~~~~~~~~~~~

* Move sprite:

MOVE_SPR  dc.w      $0100,$0000         form, time/adaption
          dc.w      16,10               x size, y size
          dc.w      8,4                 x origin, y origin
          dc.l      MOVE_CP-*           pointer to colour pattern
          dc.l      MOVE_PM-*           pointer to pattern mask
          dc.l      0                   pointer to next definition

MOVE_CP   dc.w      $0000,$0000
          dc.w      $3F3F,$C0C0
          dc.w      $303F,$C0C0
          dc.w      $303F,$C0C0
          dc.w      $333F,$FCFC
          dc.w      $3F3F,$CCFC
          dc.w      $0303,$0CFC
          dc.w      $0303,$0CFC
          dc.w      $0303,$FCFC
          dc.w      $0000,$0000

MOVE_PM   dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF

* Stick sprite:

STIK_SPR  dc.w      $0100,$0000         form, time/adaption
          dc.w      16,10               x size, y size
          dc.w      0,0                 x origin, y origin
          dc.l      STIK_CP-*           pointer to colour pattern
          dc.l      UNST_PM-*           pointer to pattern mask
          dc.l      0                   pointer to next definition

STIK_CP   dc.w      $0000,$0000
          dc.w      $0003,$00C0
          dc.w      $0106,$C020
          dc.w      $030C,$E010
          dc.w      $030C,$E010
          dc.w      $030C,$E010
          dc.w      $010E,$C030
          dc.w      $0007,$00E0
          dc.w      $0003,$00C0
          dc.w      $0000,$0000

STIK_PM   dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF

* Unstick sprite:

UNST_SPR  dc.w      $0100,$0000         form, time/adaption
          dc.w      16,10               x size, y size
          dc.w      0,0                 x origin, y origin
          dc.l      UNST_CP-*           pointer to colour pattern
          dc.l      UNST_PM-*           pointer to pattern mask
          dc.l      0                   pointer to next definition

UNST_CP   dc.w      $0000,$0000
          dc.w      $0001,$0000
          dc.w      $0001,$009C
          dc.w      $0001,$02FC
          dc.w      $7E7F,$02FC
          dc.w      $0001,$02FC
          dc.w      $0001,$009C
          dc.w      $0001,$0000
          dc.w      $0000,$0000
          dc.w      $0000,$0000

UNST_PM   dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF
          dc.w      $FFFF,$FFFF

* "ESC" object:

ESC_OBJ   dc.w      3
          dc.b      'ESC',0

* "none" object:

NONE_OBJ  dc.w      4
          dc.b      'none'

* "Argument" objects:

ARG_OBJ   dc.w      19
          dc.b      'Argument / Repeat :',0

FAKE_ARG  dc.w      1
          dc.b      ' ',0

* Sprites for ql_c main menu:

_info_spr dc.w      $0100,$0000         form, time/adaption
          dc.w      20,13               x size, y size
          dc.w      0,0                 x origin, y origin
          dc.l      INFO_CP-*           pointer to colour pattern
          dc.l      INFO_PM-*           pointer to pattern mask
          dc.l      0                   pointer to next definition

INFO_CP   dc.w      $0000,$0000,$0000,$0000
          dc.w      $0000,$0000,$0000,$0000
          dc.w      $0000,$C0C0,$0000,$0000
          dc.w      $0000,$C0C0,$0000,$0000
          dc.w      $0000,$0000,$0000,$0000
          dc.w      $0000,$C0C0,$0000,$0000
          dc.w      $0000,$C0C0,$0000,$0000
          dc.w      $0000,$C0C0,$0000,$0000
          dc.w      $0000,$C8C8,$0000,$0000
          dc.w      $0000,$D0D0,$0000,$0000
          dc.w      $0000,$6060,$0000,$0000
          dc.w      $0000,$0000,$0000,$0000
          dc.w      $0000,$0000,$0000,$0000

INFO_PM   dc.w      $FFFF,$FFFF,$F0F0,$0000
          dc.w      $FFFF,$FFFF,$F0F0,$0000
          dc.w      $FFFF,$FFFF,$F0F0,$0000
          dc.w      $FFFF,$FFFF,$F0F0,$0000
          dc.w      $FFFF,$FFFF,$F0F0,$0000
          dc.w      $FFFF,$FFFF,$F0F0,$0000
          dc.w      $FFFF,$FFFF,$F0F0,$0000
          dc.w      $FFFF,$FFFF,$F0F0,$0000
          dc.w      $FFFF,$FFFF,$F0F0,$0000
          dc.w      $FFFF,$FFFF,$F0F0,$0000
          dc.w      $FFFF,$FFFF,$F0F0,$0000
          dc.w      $FFFF,$FFFF,$F0F0,$0000
          dc.w      $FFFF,$FFFF,$F0F0,$0000

_pgdn_spr dc.w      $0100,$0000         form, time/adaption
          dc.w      12,11               x size, y size
          dc.w      0,0                 x origin, y origin
          dc.l      PGDN_CP-*           pointer to colour pattern
          dc.l      PGDN_PM-*           pointer to pattern mask
          dc.l      0                   pointer to next definition

PGDN_CP   dc.w      $1F1F,$E0E0
          dc.w      $3010,$2020
          dc.w      $7070,$2020
          dc.w      $4046,$2020
          dc.w      $4046,$2020
          dc.w      $4046,$2020
          dc.w      $405F,$20A0
          dc.w      $404F,$2020
          dc.w      $4046,$2020
          dc.w      $4040,$2020
          dc.w      $7F7F,$E0E0

PGDN_PM   dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0

_pgup_spr dc.w      $0100,$0000         form, time/adaption
          dc.w      12,11               x size, y size
          dc.w      0,0                 x origin, y origin
          dc.l      PGUP_CP-*           pointer to colour pattern
          dc.l      PGUP_PM-*           pointer to pattern mask
          dc.l      0                   pointer to next definition

PGUP_CP   dc.w      $1F1F,$E0E0
          dc.w      $3010,$2020
          dc.w      $7070,$2020
          dc.w      $4046,$2020
          dc.w      $404F,$2020
          dc.w      $405F,$20A0
          dc.w      $4046,$2020
          dc.w      $4046,$2020
          dc.w      $4046,$2020
          dc.w      $4040,$2020
          dc.w      $7F7F,$E0E0

PGUP_PM   dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0
          dc.w      $FFFF,$F0F0

_curs_spr dc.w      $0100,$0000         form, time/adaption
          dc.w      6,10                x size, y size
          dc.w      2,4                 x origin, y origin
          dc.l      CURS_CP-*           pointer to colour pattern
          dc.l      CURS_PM-*           pointer to pattern mask
          dc.l      0                   pointer to next definition

CURS_CP   dc.w      $00FC,$0000
          dc.w      $00FC,$0000
          dc.w      $00FC,$0000
          dc.w      $00FC,$0000
          dc.w      $00FC,$0000
          dc.w      $00FC,$0000
          dc.w      $00FC,$0000
          dc.w      $00FC,$0000
          dc.w      $00FC,$0000
          dc.w      $00FC,$0000

CURS_PM   dc.w      $0000,$0000
          dc.w      $0000,$0000
          dc.w      $0000,$0000
          dc.w      $0000,$0000
          dc.w      $0000,$0000
          dc.w      $0000,$0000
          dc.w      $0000,$0000
          dc.w      $0000,$0000
          dc.w      $0000,$0000
          dc.w      $0000,$0000

* Hand sprites common to all menus (including ql_c main menu):

_hand_spr dc.w      $0100,$0000         form, time/adaption
          dc.w      22,15               x size, y size
          dc.w      2,1                 x origin, y origin
          dc.l      HAND_CP-*           pointer to colour pattern
          dc.l      HAND_PM-*           pointer to pattern mask
          dc.l      0                   pointer to next definition

HAND_CP   dc.w      $0000,$0000,$0000,$0000
          dc.w      $3838,$0000,$0000,$0000
          dc.w      $1C1C,$0000,$0000,$0000
          dc.w      $0E0E,$0000,$0000,$0000
          dc.w      $0707,$B6B6,$C0C0,$0000
          dc.w      $0303,$DBDB,$E0E0,$0000
          dc.w      $0101,$EFEF,$E0E0,$0000
          dc.w      $0202,$FFFF,$E0E0,$0000
          dc.w      $0707,$7F7F,$E0E0,$0000
          dc.w      $0303,$BFBF,$F0F0,$0000
          dc.w      $0101,$FFFF,$F0F0,$0000
          dc.w      $0000,$7F7F,$F0F0,$0000
          dc.w      $0000,$0101,$E0E0,$0000
          dc.w      $0000,$0000,$C0C0,$0000
          dc.w      $0000,$0000,$0000,$0000

HAND_PM   dc.w      $7C7C,$0000,$0000,$0000
          dc.w      $FEFE,$0000,$0000,$0000
          dc.w      $7F7F,$0000,$0000,$0000
          dc.w      $3F3F,$FFFF,$E0E0,$0000
          dc.w      $1F1F,$FFFF,$F0F0,$0000
          dc.w      $0F0F,$FFFF,$F8F8,$0000
          dc.w      $0707,$FFFF,$F8F8,$0000
          dc.w      $0F0F,$FFFF,$F8F8,$0000
          dc.w      $1F1F,$FFFF,$F8F8,$0000
          dc.w      $0F0F,$FFFF,$FCFC,$0000
          dc.w      $0707,$FFFF,$FCFC,$0000
          dc.w      $0303,$FFFF,$FCFC,$0000
          dc.w      $0000,$FFFF,$F8F8,$0000
          dc.w      $0000,$0303,$F0F0,$0000
          dc.w      $0000,$0000,$E0E0,$0000

_fist_spr dc.w      $0100,$0000         form, time/adaption
          dc.w      16,19               x size, y size 
          dc.w      4,2                 x origin, y origin 
          dc.l      fist_cp-*           pointer to colour pattern
          dc.l      fist_pm-*           pointer to pattern mask
          dc.l      0                   pointer to next definition 

fist_cp   dc.w      $0000,$0000,$0101,$8080
          dc.w      $0D0D,$B0B0,$0D0D,$B0B0
          dc.w      $0D0D,$B6B6,$4D4D,$F6F6
          dc.w      $6F6F,$FEFE,$6F6F,$FEFE
          dc.w      $6F6F,$FEFE,$7F7F,$FEFE
          dc.w      $3F3F,$FEFE,$1F1F,$FEFE
          dc.w      $0F0F,$FCFC,$0707,$FCFC
          dc.w      $0303,$F8F8,$0303,$F8F8
          dc.w      $0303,$F8F8,$0303,$F8F8
          dc.w      $0000,$0000

fist_pm   dc.w      $0303,$C0C0,$1F1F,$F8F8
          dc.w      $1F1F,$F8F8,$1F1F,$FFFF
          dc.w      $DFDF,$FFFF,$FFFF,$FFFF
          dc.w      $FFFF,$FFFF,$FFFF,$FFFF
          dc.w      $FFFF,$FFFF,$FFFF,$FFFF
          dc.w      $FFFF,$FFFF,$7F7F,$FFFF
          dc.w      $3F3F,$FFFF,$1F1F,$FEFE
          dc.w      $0F0F,$FEFE,$0707,$FCFC
          dc.w      $0707,$FCFC,$0707,$FCFC
          dc.w      $0303,$FCFC

          end
